/* connection.c generated by valac 0.22.1, the Vala compiler
 * generated from connection.vala, do not modify */

/*
 * Copyright 2011-2012 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <libsoup/soup-cache.h>


#define DIORITE_TYPE_PROXY_SETTINGS (diorite_proxy_settings_get_type ())

#define DIORITE_TYPE_PROXY_TYPE (diorite_proxy_type_get_type ())

#define DIORITE_TYPE_CONNECTION (diorite_connection_get_type ())
#define DIORITE_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_CONNECTION, DioriteConnection))
#define DIORITE_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_CONNECTION, DioriteConnectionClass))
#define DIORITE_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_CONNECTION))
#define DIORITE_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_CONNECTION))
#define DIORITE_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_CONNECTION, DioriteConnectionClass))

typedef struct _DioriteConnection DioriteConnection;
typedef struct _DioriteConnectionClass DioriteConnectionClass;
typedef struct _DioriteConnectionPrivate DioriteConnectionPrivate;

#define DIORITE_TYPE_STORAGE (diorite_storage_get_type ())
#define DIORITE_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_STORAGE, DioriteStorage))
#define DIORITE_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_STORAGE, DioriteStorageClass))
#define DIORITE_IS_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_STORAGE))
#define DIORITE_IS_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_STORAGE))
#define DIORITE_STORAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_STORAGE, DioriteStorageClass))

typedef struct _DioriteStorage DioriteStorage;
typedef struct _DioriteStorageClass DioriteStorageClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DIORITE_PROXY_SETTINGS_AUTO,
	DIORITE_PROXY_SETTINGS_MANUAL,
	DIORITE_PROXY_SETTINGS_NONE
} DioriteProxySettings;

typedef enum  {
	DIORITE_PROXY_TYPE_HTTP,
	DIORITE_PROXY_TYPE_SOCKS
} DioriteProxyType;

typedef enum  {
	DIORITE_PROXY_ERROR_SOCKS_NOT_AVAILABLE,
	DIORITE_PROXY_ERROR_NO_PROXY_SERVER,
	DIORITE_PROXY_ERROR_NO_PROXY_TYPE,
	DIORITE_PROXY_ERROR_NO_PROXY_PORT
} DioriteProxyError;
#define DIORITE_PROXY_ERROR diorite_proxy_error_quark ()
struct _DioriteConnection {
	GObject parent_instance;
	DioriteConnectionPrivate * priv;
};

struct _DioriteConnectionClass {
	GObjectClass parent_class;
};

struct _DioriteConnectionPrivate {
	DioriteStorage* storage;
	SoupSession* _session;
	gboolean proxy_is_set;
};


extern gint diorite_LIBSOUP_VERSION[3];
gint diorite_LIBSOUP_VERSION[3] = {0};
extern gchar* diorite_LIBSOUP_VERSION_STRING;
gchar* diorite_LIBSOUP_VERSION_STRING = NULL;
static gpointer diorite_connection_parent_class = NULL;

void soup_session_add_feature (SoupSession* session, SoupSessionFeature* feature);
void soup_session_add_feature_by_type (SoupSession* session, GType feature_type);
void soup_session_remove_feature_by_type (SoupSession* session, GType feature_type);
#define DIORITE_TSOCKS_CONF "tsocks.conf"
#define DIORITE_COOKIES "cookies.dat"
GType diorite_proxy_settings_get_type (void) G_GNUC_CONST;
GType diorite_proxy_type_get_type (void) G_GNUC_CONST;
GQuark diorite_proxy_error_quark (void);
GType diorite_connection_get_type (void) G_GNUC_CONST;
GType diorite_storage_get_type (void) G_GNUC_CONST;
#define DIORITE_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_CONNECTION, DioriteConnectionPrivate))
enum  {
	DIORITE_CONNECTION_DUMMY_PROPERTY,
	DIORITE_CONNECTION_SESSION
};
void diorite_connection_dump_cache (DioriteConnection* self);
DioriteConnection* diorite_connection_new_with_session (SoupSession* session, DioriteStorage* storage, SoupLoggerLogLevel logging);
DioriteConnection* diorite_connection_construct_with_session (GType object_type, SoupSession* session, DioriteStorage* storage, SoupLoggerLogLevel logging);
static void diorite_connection_parse_libsoup_version (void);
static void diorite_connection_set_session (DioriteConnection* self, SoupSession* value);
void diorite_connection_set_up_proxy (DioriteConnection* self, DioriteProxySettings mode, DioriteProxyType type, const gchar* server, const gchar* port, GError** error);
GFile* diorite_storage_get_config_path (DioriteStorage* self, const gchar* path);
void diorite_logger_lib_debug (const gchar* format, ...);
void diorite_system_overwrite_file (GFile* file, const gchar* contents, GError** error);
gboolean diorite_connection_have_socks (gchar** _error_);
void diorite_logger_lib_warning (const gchar* format, ...);
SoupSession* diorite_connection_get_session (DioriteConnection* self);
static void _vala_SoupURI_free (SoupURI* self);
void diorite_connection_set_up_cookies (DioriteConnection* self, gboolean clear);
gboolean diorite_connection_enable_cache (DioriteConnection* self, gint max_size);
GFile* diorite_storage_get_cache_path (DioriteStorage* self, const gchar* path);
gboolean diorite_connection_disable_cache (DioriteConnection* self);
gboolean diorite_connection_clear_cache (DioriteConnection* self);
gboolean diorite_connection_download_file (DioriteConnection* self, const gchar* uri, GFile* local_file, guint** status);
static guint* _uint_dup (guint* self);
void diorite_logger_lib_critical (const gchar* format, ...);
gchar* diorite_connection_libsoup_version_string (void);
DioriteConnection* diorite_connection_new (void);
DioriteConnection* diorite_connection_construct (GType object_type);
static void diorite_connection_finalize (GObject* obj);
static void _vala_diorite_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diorite_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Proxy settings
 * 
 * AUTO = http_proxy and https_proxy environment variables are used to resolve proxy
 * settings; MANUAL = manual proxy settings is used (type, server and port);
 * NONE = direct network connection is used
 */
GType diorite_proxy_settings_get_type (void) {
	static volatile gsize diorite_proxy_settings_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_proxy_settings_type_id__volatile)) {
		static const GEnumValue values[] = {{DIORITE_PROXY_SETTINGS_AUTO, "DIORITE_PROXY_SETTINGS_AUTO", "auto"}, {DIORITE_PROXY_SETTINGS_MANUAL, "DIORITE_PROXY_SETTINGS_MANUAL", "manual"}, {DIORITE_PROXY_SETTINGS_NONE, "DIORITE_PROXY_SETTINGS_NONE", "none"}, {0, NULL, NULL}};
		GType diorite_proxy_settings_type_id;
		diorite_proxy_settings_type_id = g_enum_register_static ("DioriteProxySettings", values);
		g_once_init_leave (&diorite_proxy_settings_type_id__volatile, diorite_proxy_settings_type_id);
	}
	return diorite_proxy_settings_type_id__volatile;
}


/**
 * Type of proxy server
 * 
 * HTTP = HTTP(S) proxy server; SOCKS = SOCKS4 or SOCKS5 proxy server
 */
GType diorite_proxy_type_get_type (void) {
	static volatile gsize diorite_proxy_type_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_proxy_type_type_id__volatile)) {
		static const GEnumValue values[] = {{DIORITE_PROXY_TYPE_HTTP, "DIORITE_PROXY_TYPE_HTTP", "http"}, {DIORITE_PROXY_TYPE_SOCKS, "DIORITE_PROXY_TYPE_SOCKS", "socks"}, {0, NULL, NULL}};
		GType diorite_proxy_type_type_id;
		diorite_proxy_type_type_id = g_enum_register_static ("DioriteProxyType", values);
		g_once_init_leave (&diorite_proxy_type_type_id__volatile, diorite_proxy_type_type_id);
	}
	return diorite_proxy_type_type_id__volatile;
}


GQuark diorite_proxy_error_quark (void) {
	return g_quark_from_static_string ("diorite_proxy_error-quark");
}


/**
 * Construct new connection manager
 * 
 * @param session session used for connections
 * @param storage storage for cookies and cache
 */
static gpointer _g_object_ref0 (gpointer self) {
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return self ? g_object_ref (self) : NULL;
#line 205 "connection.c"
}


DioriteConnection* diorite_connection_construct_with_session (GType object_type, SoupSession* session, DioriteStorage* storage, SoupLoggerLogLevel logging) {
	DioriteConnection * self = NULL;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gboolean _tmp6_ = FALSE;
	DioriteStorage* _tmp7_ = NULL;
	DioriteStorage* _tmp8_ = NULL;
	SoupSession* _tmp9_ = NULL;
	SoupLoggerLogLevel _tmp10_ = 0;
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_val_if_fail (session != NULL, NULL);
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_val_if_fail (storage != NULL, NULL);
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	self = (DioriteConnection*) g_object_new (object_type, NULL);
#line 91 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	diorite_connection_parse_libsoup_version ();
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = diorite_LIBSOUP_VERSION[0];
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp1_ > 2) {
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp0_ = TRUE;
#line 232 "connection.c"
	} else {
		gboolean _tmp2_ = FALSE;
		gint _tmp3_ = 0;
		gboolean _tmp5_ = FALSE;
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp3_ = diorite_LIBSOUP_VERSION[0];
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_tmp3_ == 2) {
#line 241 "connection.c"
			gint _tmp4_ = 0;
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp4_ = diorite_LIBSOUP_VERSION[1];
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp2_ = _tmp4_ >= 38;
#line 247 "connection.c"
		} else {
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp2_ = FALSE;
#line 251 "connection.c"
		}
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp5_ = _tmp2_;
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp0_ = _tmp5_;
#line 257 "connection.c"
	}
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp6_ = _tmp0_;
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_vala_assert (_tmp6_, "LIBSOUP_VERSION[0] > 2 || (LIBSOUP_VERSION[0] == 2 && LIBSOUP_VERSION[1] >= 38)");
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp7_ = storage;
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (self->priv->storage);
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	self->priv->storage = _tmp8_;
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp9_ = session;
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	diorite_connection_set_session (self, _tmp9_);
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp10_ = logging;
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp10_ != SOUP_LOGGER_LOG_NONE) {
#line 279 "connection.c"
		SoupLogger* logger = NULL;
		SoupLoggerLogLevel _tmp11_ = 0;
		SoupLogger* _tmp12_ = NULL;
		SoupSession* _tmp13_ = NULL;
		SoupLogger* _tmp14_ = NULL;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp11_ = logging;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp12_ = soup_logger_new (_tmp11_, 1024);
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		logger = _tmp12_;
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp13_ = session;
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp14_ = logger;
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		soup_session_add_feature (_tmp13_, (SoupSessionFeature*) _tmp14_);
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (logger);
#line 299 "connection.c"
	}
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return self;
#line 303 "connection.c"
}


DioriteConnection* diorite_connection_new_with_session (SoupSession* session, DioriteStorage* storage, SoupLoggerLogLevel logging) {
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return diorite_connection_construct_with_session (DIORITE_TYPE_CONNECTION, session, storage, logging);
#line 310 "connection.c"
}


/**
 * Setup network proxy
 * 
 * @param mode Mode used for proxy settings
 * @param type Type of proxy server. Used only with manual mode.
 * @param server Address of proxy server. Used only with manual mode.
 * @param port Port of proxy server. Used only with manual mode.
 * @throws ProxyError on failure
 **/
static void _vala_SoupURI_free (SoupURI* self) {
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_boxed_free (soup_uri_get_type (), self);
#line 326 "connection.c"
}


void diorite_connection_set_up_proxy (DioriteConnection* self, DioriteProxySettings mode, DioriteProxyType type, const gchar* server, const gchar* port, GError** error) {
	DioriteProxySettings _tmp0_ = 0;
	gboolean _tmp5_ = FALSE;
	SoupSession* _tmp30_ = NULL;
	SoupSession* _tmp31_ = NULL;
	SoupSession* _tmp32_ = NULL;
	SoupSession* _tmp33_ = NULL;
	gchar* proxy = NULL;
	DioriteProxySettings _tmp34_ = 0;
	gboolean _tmp42_ = FALSE;
	const gchar* _tmp43_ = NULL;
	gboolean _tmp45_ = FALSE;
	GError * _inner_error_ = NULL;
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_if_fail (self != NULL);
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = mode;
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp0_ == DIORITE_PROXY_SETTINGS_MANUAL) {
#line 349 "connection.c"
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 121 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp1_ = server;
#line 121 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_tmp1_ == NULL) {
#line 356 "connection.c"
			GError* _tmp2_ = NULL;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp2_ = g_error_new_literal (DIORITE_PROXY_ERROR, DIORITE_PROXY_ERROR_NO_PROXY_SERVER, "Proxy server is not specified");
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_inner_error_ = _tmp2_;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (_inner_error_->domain == DIORITE_PROXY_ERROR) {
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				g_propagate_error (error, _inner_error_);
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				return;
#line 368 "connection.c"
			} else {
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				g_clear_error (&_inner_error_);
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				return;
#line 376 "connection.c"
			}
		}
#line 124 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp3_ = port;
#line 124 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_tmp3_ == NULL) {
#line 383 "connection.c"
			GError* _tmp4_ = NULL;
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp4_ = g_error_new_literal (DIORITE_PROXY_ERROR, DIORITE_PROXY_ERROR_NO_PROXY_PORT, "Proxy port is not specified");
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_inner_error_ = _tmp4_;
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (_inner_error_->domain == DIORITE_PROXY_ERROR) {
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				g_propagate_error (error, _inner_error_);
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				return;
#line 395 "connection.c"
			} else {
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				g_clear_error (&_inner_error_);
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				return;
#line 403 "connection.c"
			}
		}
	}
#line 131 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp5_ = self->priv->proxy_is_set;
#line 131 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp5_) {
#line 411 "connection.c"
		GFile* tsocks_conf_file = NULL;
		DioriteStorage* _tmp6_ = NULL;
		GFile* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		DioriteProxySettings _tmp9_ = 0;
		gboolean _tmp11_ = FALSE;
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp6_ = self->priv->storage;
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp7_ = diorite_storage_get_config_path (_tmp6_, DIORITE_TSOCKS_CONF);
#line 132 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		tsocks_conf_file = _tmp7_;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp9_ = mode;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_tmp9_ == DIORITE_PROXY_SETTINGS_MANUAL) {
#line 428 "connection.c"
			DioriteProxyType _tmp10_ = 0;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp10_ = type;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp8_ = _tmp10_ == DIORITE_PROXY_TYPE_SOCKS;
#line 434 "connection.c"
		} else {
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp8_ = FALSE;
#line 438 "connection.c"
		}
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp11_ = _tmp8_;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_tmp11_) {
#line 444 "connection.c"
			const gchar* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
			gchar* conf = NULL;
			const gchar* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			gchar* _tmp16_ = NULL;
			gboolean _tmp25_ = FALSE;
#line 135 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp12_ = server;
#line 135 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp13_ = port;
#line 135 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			diorite_logger_lib_debug ("Setting proxy (manual): socks://%s:%s", _tmp12_, _tmp13_, NULL);
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp14_ = server;
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp15_ = port;
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp16_ = g_strdup_printf ("server = %s\nserver_port = %s\n", _tmp14_, _tmp15_);
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			conf = _tmp16_;
#line 466 "connection.c"
			{
				GFile* _tmp17_ = NULL;
				const gchar* _tmp18_ = NULL;
#line 139 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_tmp17_ = tsocks_conf_file;
#line 139 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_tmp18_ = conf;
#line 139 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				diorite_system_overwrite_file (_tmp17_, _tmp18_, &_inner_error_);
#line 139 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				if (_inner_error_ != NULL) {
#line 478 "connection.c"
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GError* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				gchar* _tmp22_ = NULL;
				GError* _tmp23_ = NULL;
				GError* _tmp24_ = NULL;
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				e = _inner_error_;
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_inner_error_ = NULL;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_tmp19_ = e;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_tmp20_ = _tmp19_->message;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_tmp21_ = g_strdup_printf ("Unable to store SOCKS config file: %s", _tmp20_);
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_tmp22_ = _tmp21_;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_tmp23_ = g_error_new_literal (DIORITE_PROXY_ERROR, DIORITE_PROXY_ERROR_SOCKS_NOT_AVAILABLE, _tmp22_);
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_tmp24_ = _tmp23_;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_g_free0 (_tmp22_);
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_inner_error_ = _tmp24_;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_g_error_free0 (e);
#line 514 "connection.c"
				goto __finally1;
			}
			__finally1:
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (_inner_error_ != NULL) {
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				if (_inner_error_->domain == DIORITE_PROXY_ERROR) {
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					g_propagate_error (error, _inner_error_);
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_g_free0 (conf);
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_g_object_unref0 (tsocks_conf_file);
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					return;
#line 530 "connection.c"
				} else {
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_g_free0 (conf);
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_g_object_unref0 (tsocks_conf_file);
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					g_clear_error (&_inner_error_);
#line 138 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					return;
#line 542 "connection.c"
				}
			}
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp25_ = diorite_connection_have_socks (NULL);
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (!_tmp25_) {
#line 549 "connection.c"
				GError* _tmp26_ = NULL;
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_tmp26_ = g_error_new_literal (DIORITE_PROXY_ERROR, DIORITE_PROXY_ERROR_SOCKS_NOT_AVAILABLE, "Unable to initialize SOCKS proxy wrapper");
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				_inner_error_ = _tmp26_;
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				if (_inner_error_->domain == DIORITE_PROXY_ERROR) {
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					g_propagate_error (error, _inner_error_);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_g_free0 (conf);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_g_object_unref0 (tsocks_conf_file);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					return;
#line 565 "connection.c"
				} else {
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_g_free0 (conf);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_g_object_unref0 (tsocks_conf_file);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					g_clear_error (&_inner_error_);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					return;
#line 577 "connection.c"
				}
			}
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_free0 (conf);
#line 582 "connection.c"
		} else {
			GFile* _tmp27_ = NULL;
			gboolean _tmp28_ = FALSE;
#line 154 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp27_ = tsocks_conf_file;
#line 154 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp28_ = g_file_query_exists (_tmp27_, NULL);
#line 154 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (_tmp28_) {
#line 592 "connection.c"
				{
					GFile* _tmp29_ = NULL;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_tmp29_ = tsocks_conf_file;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					g_file_delete (_tmp29_, NULL, &_inner_error_);
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					if (_inner_error_ != NULL) {
#line 601 "connection.c"
						goto __catch2_g_error;
					}
				}
				goto __finally2;
				__catch2_g_error:
				{
					GError* e = NULL;
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					e = _inner_error_;
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_inner_error_ = NULL;
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					diorite_logger_lib_warning ("Unable to discard SOCKS settings", NULL);
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					_g_error_free0 (e);
#line 617 "connection.c"
				}
				__finally2:
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
				if (_inner_error_ != NULL) {
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
					if (_inner_error_->domain == DIORITE_PROXY_ERROR) {
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
						g_propagate_error (error, _inner_error_);
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
						_g_object_unref0 (tsocks_conf_file);
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
						return;
#line 630 "connection.c"
					} else {
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
						_g_object_unref0 (tsocks_conf_file);
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
						g_clear_error (&_inner_error_);
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
						return;
#line 640 "connection.c"
					}
				}
			}
		}
#line 167 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (tsocks_conf_file);
#line 167 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return;
#line 649 "connection.c"
	}
#line 171 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp30_ = self->priv->_session;
#line 171 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_session_abort (_tmp30_);
#line 172 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp31_ = self->priv->_session;
#line 172 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_session_remove_feature_by_type (_tmp31_, soup_proxy_uri_resolver_get_type ());
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp32_ = self->priv->_session;
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_session_remove_feature_by_type (_tmp32_, soup_proxy_resolver_default_get_type ());
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp33_ = self->priv->_session;
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_object_set (_tmp33_, "proxy-uri", NULL, NULL);
#line 177 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	proxy = NULL;
#line 178 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp34_ = mode;
#line 178 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp34_ == DIORITE_PROXY_SETTINGS_MANUAL) {
#line 673 "connection.c"
		DioriteProxyType _tmp35_ = 0;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp35_ = type;
#line 179 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_tmp35_ != DIORITE_PROXY_TYPE_SOCKS) {
#line 679 "connection.c"
			const gchar* _tmp36_ = NULL;
			const gchar* _tmp37_ = NULL;
			gchar* _tmp38_ = NULL;
			const gchar* _tmp39_ = NULL;
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp36_ = server;
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp37_ = port;
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp38_ = g_strdup_printf ("http://%s:%s", _tmp36_, _tmp37_);
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_free0 (proxy);
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			proxy = _tmp38_;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp39_ = proxy;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			diorite_logger_lib_debug ("Setting proxy (manual): %s", _tmp39_, NULL);
#line 698 "connection.c"
		}
	} else {
		DioriteProxySettings _tmp40_ = 0;
#line 184 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp40_ = mode;
#line 184 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_tmp40_ == DIORITE_PROXY_SETTINGS_AUTO) {
#line 706 "connection.c"
			SoupSession* _tmp41_ = NULL;
#line 186 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			diorite_logger_lib_debug ("Setting proxy (auto): %s", "dynamic resolver", NULL);
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp41_ = self->priv->_session;
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			soup_session_add_feature_by_type (_tmp41_, soup_proxy_resolver_default_get_type ());
#line 714 "connection.c"
		} else {
#line 191 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			diorite_logger_lib_debug ("No proxy settings applied.", NULL);
#line 718 "connection.c"
		}
	}
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp43_ = proxy;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp43_ != NULL) {
#line 725 "connection.c"
		const gchar* _tmp44_ = NULL;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp44_ = proxy;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp42_ = g_strcmp0 (_tmp44_, "") != 0;
#line 731 "connection.c"
	} else {
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp42_ = FALSE;
#line 735 "connection.c"
	}
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp45_ = _tmp42_;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp45_) {
#line 741 "connection.c"
		SoupSession* _tmp46_ = NULL;
		const gchar* _tmp47_ = NULL;
		SoupURI* _tmp48_ = NULL;
		SoupURI* _tmp49_ = NULL;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp46_ = self->priv->_session;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp47_ = proxy;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp48_ = soup_uri_new (_tmp47_);
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp49_ = _tmp48_;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_object_set (_tmp46_, "proxy-uri", _tmp49_, NULL);
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		__vala_SoupURI_free0 (_tmp49_);
#line 758 "connection.c"
	}
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	self->priv->proxy_is_set = TRUE;
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_free0 (proxy);
#line 764 "connection.c"
}


gboolean diorite_connection_have_socks (gchar** _error_) {
	gchar* _vala_error = NULL;
	gboolean result = FALSE;
	gint _result_ = 0;
	gint _tmp7_ = 0;
	GError * _inner_error_ = NULL;
#line 203 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_result_ = -1;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_free0 (_vala_error);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_vala_error = NULL;
#line 780 "connection.c"
	{
		gchar** args = NULL;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar** _tmp2_ = NULL;
		gint args_length1 = 0;
		gint _args_size_ = 0;
		gchar** _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
		gint _tmp4_ = 0;
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp0_ = g_strdup ("which");
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp1_ = g_strdup ("tsocks");
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp2_[0] = _tmp0_;
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp2_[1] = _tmp1_;
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		args = _tmp2_;
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		args_length1 = 2;
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_args_size_ = args_length1;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp3_ = args;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp3__length1 = args_length1;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_spawn_sync (NULL, _tmp3_, NULL, (G_SPAWN_SEARCH_PATH | G_SPAWN_STDOUT_TO_DEV_NULL) | G_SPAWN_STDERR_TO_DEV_NULL, NULL, NULL, NULL, NULL, &_tmp4_, &_inner_error_);
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_result_ = _tmp4_;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_inner_error_ != NULL) {
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (_inner_error_->domain == G_SPAWN_ERROR) {
#line 821 "connection.c"
				goto __catch3_g_spawn_error;
			}
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_clear_error (&_inner_error_);
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			return FALSE;
#line 832 "connection.c"
		}
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 836 "connection.c"
	}
	goto __finally3;
	__catch3_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		e = _inner_error_;
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_inner_error_ = NULL;
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp5_ = e;
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp6_ = _tmp5_->message;
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		diorite_logger_lib_warning ("SpawnError: %s", _tmp6_, NULL);
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		result = FALSE;
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_error_free0 (e);
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_error_) {
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			*_error_ = _vala_error;
#line 862 "connection.c"
		} else {
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_free0 (_vala_error);
#line 866 "connection.c"
		}
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return result;
#line 870 "connection.c"
	}
	__finally3:
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_inner_error_ != NULL) {
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_clear_error (&_inner_error_);
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return FALSE;
#line 881 "connection.c"
	}
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp7_ = _result_;
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	result = _tmp7_ == 0;
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_error_) {
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		*_error_ = _vala_error;
#line 891 "connection.c"
	} else {
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_free0 (_vala_error);
#line 895 "connection.c"
	}
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return result;
#line 899 "connection.c"
}


/**
 * Set up cookies
 * 
 * @param clear also clears cookies storage if true
 */
void diorite_connection_set_up_cookies (DioriteConnection* self, gboolean clear) {
	GFile* file = NULL;
	DioriteStorage* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp6_ = FALSE;
	SoupSessionFeature* feature = NULL;
	SoupSession* _tmp11_ = NULL;
	SoupSessionFeature* _tmp12_ = NULL;
	SoupSessionFeature* _tmp13_ = NULL;
	SoupSession* _tmp16_ = NULL;
	GFile* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	SoupCookieJarText* _tmp20_ = NULL;
	SoupCookieJarText* _tmp21_ = NULL;
	GError * _inner_error_ = NULL;
#line 223 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_if_fail (self != NULL);
#line 224 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = self->priv->storage;
#line 224 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = diorite_storage_get_config_path (_tmp0_, DIORITE_COOKIES);
#line 224 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	file = _tmp1_;
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp3_ = clear;
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp3_) {
#line 938 "connection.c"
		GFile* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp4_ = file;
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp2_ = _tmp5_;
#line 947 "connection.c"
	} else {
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp2_ = FALSE;
#line 951 "connection.c"
	}
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp6_ = _tmp2_;
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp6_) {
#line 957 "connection.c"
		{
			GFile* _tmp7_ = NULL;
#line 227 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp7_ = file;
#line 227 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_file_delete (_tmp7_, NULL, &_inner_error_);
#line 227 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (_inner_error_ != NULL) {
#line 966 "connection.c"
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			GFile* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			gchar* _tmp10_ = NULL;
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			e = _inner_error_;
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_inner_error_ = NULL;
#line 230 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp8_ = file;
#line 230 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp9_ = g_file_get_path (_tmp8_);
#line 230 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp10_ = _tmp9_;
#line 230 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			diorite_logger_lib_warning ("Unable to delete cookies file: %s", _tmp10_, NULL);
#line 230 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_free0 (_tmp10_);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_error_free0 (e);
#line 993 "connection.c"
		}
		__finally4:
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_inner_error_ != NULL) {
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_object_unref0 (file);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_clear_error (&_inner_error_);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			return;
#line 1006 "connection.c"
		}
	}
#line 234 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp11_ = self->priv->_session;
#line 234 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp12_ = soup_session_get_feature (_tmp11_, soup_cookie_jar_text_get_type ());
#line 234 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	feature = _tmp12_;
#line 235 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp13_ = feature;
#line 235 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp13_ != NULL) {
#line 1019 "connection.c"
		SoupSession* _tmp14_ = NULL;
		SoupSessionFeature* _tmp15_ = NULL;
#line 235 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp14_ = self->priv->_session;
#line 235 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp15_ = feature;
#line 235 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		soup_session_remove_feature (_tmp14_, _tmp15_);
#line 1028 "connection.c"
	}
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp16_ = self->priv->_session;
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp17_ = file;
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp18_ = g_file_get_path (_tmp17_);
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp19_ = _tmp18_;
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp20_ = (SoupCookieJarText*) soup_cookie_jar_text_new (_tmp19_, FALSE);
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp21_ = _tmp20_;
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_session_add_feature (_tmp16_, (SoupSessionFeature*) _tmp21_);
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (_tmp21_);
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_free0 (_tmp19_);
#line 223 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (file);
#line 1050 "connection.c"
}


/**
 * Enable cache for HTTP objects and set its size
 * 
 * @param max_size maximal size of cache in MB
 * @return true on success, false if cache is already enabled
 */
gboolean diorite_connection_enable_cache (DioriteConnection* self, gint max_size) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	SoupCache* cache = NULL;
	SoupSession* _tmp1_ = NULL;
	SoupSessionFeature* _tmp2_ = NULL;
	SoupCache* _tmp3_ = NULL;
	SoupCache* _tmp4_ = NULL;
	GFile* dir = NULL;
	DioriteStorage* _tmp7_ = NULL;
	GFile* _tmp8_ = NULL;
	GFile* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	SoupCache* _tmp12_ = NULL;
	SoupCache* _tmp13_ = NULL;
	gint _tmp14_ = 0;
	SoupCache* _tmp15_ = NULL;
	SoupSession* _tmp16_ = NULL;
	SoupCache* _tmp17_ = NULL;
	SoupCache* _tmp18_ = NULL;
#line 245 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 246 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = max_size;
#line 246 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	diorite_logger_lib_debug ("Max data cache size: %d", _tmp0_, NULL);
#line 247 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = self->priv->_session;
#line 247 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp2_ = soup_session_get_feature (_tmp1_, soup_cache_get_type ());
#line 247 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, soup_cache_get_type ()) ? ((SoupCache*) _tmp2_) : NULL);
#line 247 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	cache = _tmp3_;
#line 248 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp4_ = cache;
#line 248 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp4_ != NULL) {
#line 1099 "connection.c"
		SoupCache* _tmp5_ = NULL;
		gint _tmp6_ = 0;
#line 249 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp5_ = cache;
#line 249 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp6_ = max_size;
#line 249 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		soup_cache_set_max_size (_tmp5_, (guint) ((_tmp6_ * 1024) * 1024));
#line 250 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		result = FALSE;
#line 250 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (cache);
#line 250 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return result;
#line 1114 "connection.c"
	}
#line 253 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp7_ = self->priv->storage;
#line 253 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp8_ = diorite_storage_get_cache_path (_tmp7_, "browser");
#line 253 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	dir = _tmp8_;
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp9_ = dir;
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp10_ = g_file_get_path (_tmp9_);
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp11_ = _tmp10_;
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp12_ = soup_cache_new (_tmp11_, SOUP_CACHE_SINGLE_USER);
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (cache);
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	cache = _tmp12_;
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_free0 (_tmp11_);
#line 255 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp13_ = cache;
#line 255 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp14_ = max_size;
#line 255 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_cache_set_max_size (_tmp13_, (guint) ((_tmp14_ * 1024) * 1024));
#line 256 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp15_ = cache;
#line 256 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_cache_load (_tmp15_);
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp16_ = self->priv->_session;
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp17_ = cache;
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	cache = NULL;
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp18_ = _tmp17_;
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_session_add_feature (_tmp16_, (SoupSessionFeature*) _tmp18_);
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (_tmp18_);
#line 258 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	result = TRUE;
#line 258 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (dir);
#line 258 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (cache);
#line 258 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return result;
#line 1166 "connection.c"
}


/**
 * Disable cache for HTTP objects
 * 
 * @return true on succes, false when cache is not enabled
 */
gboolean diorite_connection_disable_cache (DioriteConnection* self) {
	gboolean result = FALSE;
	SoupCache* cache = NULL;
	SoupSession* _tmp0_ = NULL;
	SoupSessionFeature* _tmp1_ = NULL;
	SoupCache* _tmp2_ = NULL;
	SoupCache* _tmp3_ = NULL;
	SoupSession* _tmp4_ = NULL;
	SoupCache* _tmp5_ = NULL;
#line 266 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = self->priv->_session;
#line 267 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = soup_session_get_feature (_tmp0_, soup_cache_get_type ());
#line 267 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, soup_cache_get_type ()) ? ((SoupCache*) _tmp1_) : NULL);
#line 267 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	cache = _tmp2_;
#line 268 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp3_ = cache;
#line 268 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp3_ == NULL) {
#line 268 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		result = FALSE;
#line 268 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (cache);
#line 268 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return result;
#line 1204 "connection.c"
	}
#line 270 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp4_ = self->priv->_session;
#line 270 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp5_ = cache;
#line 270 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_session_remove_feature (_tmp4_, (SoupSessionFeature*) _tmp5_);
#line 271 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	result = TRUE;
#line 271 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (cache);
#line 271 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return result;
#line 1218 "connection.c"
}


/**
 * Clear cache for HTTP objects
 * 
 * @return true on succes, false when cache is not enabled
 */
gboolean diorite_connection_clear_cache (DioriteConnection* self) {
	gboolean result = FALSE;
	SoupCache* cache = NULL;
	SoupSession* _tmp0_ = NULL;
	SoupSessionFeature* _tmp1_ = NULL;
	SoupCache* _tmp2_ = NULL;
	SoupCache* _tmp3_ = NULL;
	SoupCache* _tmp4_ = NULL;
	SoupCache* _tmp5_ = NULL;
#line 279 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 280 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = self->priv->_session;
#line 280 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = soup_session_get_feature (_tmp0_, soup_cache_get_type ());
#line 280 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, soup_cache_get_type ()) ? ((SoupCache*) _tmp1_) : NULL);
#line 280 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	cache = _tmp2_;
#line 281 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp3_ = cache;
#line 281 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp3_ == NULL) {
#line 281 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		result = FALSE;
#line 281 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (cache);
#line 281 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return result;
#line 1256 "connection.c"
	}
#line 283 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp4_ = cache;
#line 283 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_cache_clear (_tmp4_);
#line 284 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp5_ = cache;
#line 284 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_cache_flush (_tmp5_);
#line 285 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	result = TRUE;
#line 285 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (cache);
#line 285 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return result;
#line 1272 "connection.c"
}


/**
 * Dumps cache to disk
 */
void diorite_connection_dump_cache (DioriteConnection* self) {
	SoupSessionFeature* feature = NULL;
	SoupSession* _tmp0_ = NULL;
	SoupSessionFeature* _tmp1_ = NULL;
	SoupSessionFeature* _tmp2_ = NULL;
	SoupSessionFeature* _tmp3_ = NULL;
	SoupCache* cache = NULL;
	SoupSessionFeature* _tmp4_ = NULL;
	SoupCache* _tmp5_ = NULL;
#line 291 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_if_fail (self != NULL);
#line 292 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = self->priv->_session;
#line 292 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = soup_session_get_feature (_tmp0_, soup_cache_get_type ());
#line 292 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 292 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	feature = _tmp2_;
#line 293 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp3_ = feature;
#line 293 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp3_ == NULL) {
#line 293 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (feature);
#line 293 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return;
#line 1306 "connection.c"
	}
#line 294 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp4_ = feature;
#line 294 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	cache = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, soup_cache_get_type ()) ? ((SoupCache*) _tmp4_) : NULL;
#line 295 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp5_ = cache;
#line 295 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	soup_cache_dump (_tmp5_);
#line 291 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (feature);
#line 1318 "connection.c"
}


/**
 * Downloads remote file
 * 
 * @param uri		URI of remote file
 * @param File		local file data will be stored to
 * @param status	response status code
 * @return 			true on success, false on failure
 */
static guint* _uint_dup (guint* self) {
	guint* dup;
#line 309 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	dup = g_new0 (guint, 1);
#line 309 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	memcpy (dup, self, sizeof (guint));
#line 309 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return dup;
#line 1338 "connection.c"
}


static gpointer __uint_dup0 (gpointer self) {
#line 309 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return self ? _uint_dup (self) : NULL;
#line 1345 "connection.c"
}


gboolean diorite_connection_download_file (DioriteConnection* self, const gchar* uri, GFile* local_file, guint** status) {
	guint* _vala_status = NULL;
	gboolean result = FALSE;
	SoupMessage* msg = NULL;
	const gchar* _tmp0_ = NULL;
	SoupMessage* _tmp1_ = NULL;
	guint message_status = 0U;
	SoupSession* _tmp2_ = NULL;
	SoupMessage* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
	guint _tmp5_ = 0U;
	guint* _tmp6_ = NULL;
	guint _tmp7_ = 0U;
	SoupMessageBody* body = NULL;
	SoupMessage* _tmp8_ = NULL;
	SoupMessageBody* _tmp9_ = NULL;
	GFile* dir = NULL;
	GFile* _tmp10_ = NULL;
	GFile* _tmp11_ = NULL;
	GFile* _tmp12_ = NULL;
	gboolean _tmp13_ = FALSE;
	GFileOutputStream* stream = NULL;
	GError * _inner_error_ = NULL;
#line 306 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 306 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 306 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_val_if_fail (local_file != NULL, FALSE);
#line 307 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = uri;
#line 307 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = soup_message_new ("GET", _tmp0_);
#line 307 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	msg = _tmp1_;
#line 308 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp2_ = self->priv->_session;
#line 308 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp3_ = msg;
#line 308 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp4_ = soup_session_send_message (_tmp2_, _tmp3_);
#line 308 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	message_status = _tmp4_;
#line 309 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp5_ = message_status;
#line 309 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp6_ = __uint_dup0 (&_tmp5_);
#line 309 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_free0 (_vala_status);
#line 309 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_vala_status = _tmp6_;
#line 310 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp7_ = message_status;
#line 310 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp7_ != ((guint) 200)) {
#line 311 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		result = FALSE;
#line 311 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (msg);
#line 311 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (status) {
#line 311 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			*status = _vala_status;
#line 1412 "connection.c"
		} else {
#line 311 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_free0 (_vala_status);
#line 1416 "connection.c"
		}
#line 311 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return result;
#line 1420 "connection.c"
	}
#line 314 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp8_ = msg;
#line 314 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp9_ = _tmp8_->response_body;
#line 314 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	body = _tmp9_;
#line 315 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp10_ = local_file;
#line 315 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp11_ = g_file_get_parent (_tmp10_);
#line 315 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	dir = _tmp11_;
#line 316 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp12_ = dir;
#line 316 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp13_ = g_file_query_exists (_tmp12_, NULL);
#line 316 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (!_tmp13_) {
#line 1440 "connection.c"
		{
			GFile* _tmp14_ = NULL;
#line 318 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp14_ = dir;
#line 318 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_file_make_directory_with_parents (_tmp14_, NULL, &_inner_error_);
#line 318 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (_inner_error_ != NULL) {
#line 1449 "connection.c"
				goto __catch5_g_error;
			}
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError* e = NULL;
			GError* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
#line 317 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			e = _inner_error_;
#line 317 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_inner_error_ = NULL;
#line 321 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp15_ = e;
#line 321 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_tmp16_ = _tmp15_->message;
#line 321 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			diorite_logger_lib_critical ("Unable to create directory: %s", _tmp16_, NULL);
#line 317 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_error_free0 (e);
#line 1471 "connection.c"
		}
		__finally5:
#line 317 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_inner_error_ != NULL) {
#line 317 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_object_unref0 (dir);
#line 317 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_object_unref0 (msg);
#line 317 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 317 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_clear_error (&_inner_error_);
#line 317 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			return FALSE;
#line 1486 "connection.c"
		}
	}
	{
		GFileOutputStream* _tmp17_ = NULL;
		GFile* _tmp18_ = NULL;
		GFileOutputStream* _tmp19_ = NULL;
#line 327 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp18_ = local_file;
#line 327 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp19_ = g_file_replace (_tmp18_, NULL, FALSE, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 327 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp17_ = _tmp19_;
#line 327 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_inner_error_ != NULL) {
#line 1501 "connection.c"
			goto __catch6_g_error;
		}
#line 327 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (stream);
#line 327 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		stream = _tmp17_;
#line 1508 "connection.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
#line 326 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		e = _inner_error_;
#line 326 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_inner_error_ = NULL;
#line 330 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp20_ = e;
#line 330 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp21_ = _tmp20_->message;
#line 330 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		diorite_logger_lib_critical ("Unable to create local file: %s", _tmp21_, NULL);
#line 331 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		result = FALSE;
#line 331 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_error_free0 (e);
#line 331 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (stream);
#line 331 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (dir);
#line 331 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (msg);
#line 331 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (status) {
#line 331 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			*status = _vala_status;
#line 1540 "connection.c"
		} else {
#line 331 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_free0 (_vala_status);
#line 1544 "connection.c"
		}
#line 331 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return result;
#line 1548 "connection.c"
	}
	__finally6:
#line 326 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_inner_error_ != NULL) {
#line 326 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (stream);
#line 326 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (dir);
#line 326 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (msg);
#line 326 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 326 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_clear_error (&_inner_error_);
#line 326 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return FALSE;
#line 1565 "connection.c"
	}
	{
		GFileOutputStream* _tmp22_ = NULL;
		SoupMessageBody* _tmp23_ = NULL;
		guint8* _tmp24_ = NULL;
		gint _tmp24__length1 = 0;
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp22_ = stream;
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp23_ = body;
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp24_ = _tmp23_->data;
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp24__length1 = (gint) _tmp23_->length;
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_output_stream_write_all ((GOutputStream*) _tmp22_, _tmp24_, (gsize) _tmp24__length1, NULL, NULL, &_inner_error_);
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_inner_error_ != NULL) {
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 1586 "connection.c"
				goto __catch7_g_io_error;
			}
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_object_unref0 (stream);
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_object_unref0 (dir);
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_object_unref0 (msg);
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_clear_error (&_inner_error_);
#line 335 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			return FALSE;
#line 1601 "connection.c"
		}
	}
	goto __finally7;
	__catch7_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
#line 334 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		e = _inner_error_;
#line 334 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_inner_error_ = NULL;
#line 338 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp25_ = e;
#line 338 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp26_ = _tmp25_->message;
#line 338 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		diorite_logger_lib_critical ("Unable to store remote file: %s", _tmp26_, NULL);
#line 339 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		result = FALSE;
#line 339 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_error_free0 (e);
#line 339 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (stream);
#line 339 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (dir);
#line 339 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (msg);
#line 339 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (status) {
#line 339 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			*status = _vala_status;
#line 1634 "connection.c"
		} else {
#line 339 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_free0 (_vala_status);
#line 1638 "connection.c"
		}
#line 339 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return result;
#line 1642 "connection.c"
	}
	__finally7:
#line 334 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_inner_error_ != NULL) {
#line 334 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (stream);
#line 334 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (dir);
#line 334 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (msg);
#line 334 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 334 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_clear_error (&_inner_error_);
#line 334 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return FALSE;
#line 1659 "connection.c"
	}
	{
		GFileOutputStream* _tmp27_ = NULL;
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp27_ = stream;
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_output_stream_close ((GOutputStream*) _tmp27_, NULL, &_inner_error_);
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		if (_inner_error_ != NULL) {
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 1671 "connection.c"
				goto __catch8_g_io_error;
			}
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_object_unref0 (stream);
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_object_unref0 (dir);
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			_g_object_unref0 (msg);
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			g_clear_error (&_inner_error_);
#line 342 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
			return FALSE;
#line 1686 "connection.c"
		}
	}
	goto __finally8;
	__catch8_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		e = _inner_error_;
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_inner_error_ = NULL;
#line 345 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp28_ = e;
#line 345 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_tmp29_ = _tmp28_->message;
#line 345 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		diorite_logger_lib_warning ("Unable to close stream: %s", _tmp29_, NULL);
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_error_free0 (e);
#line 1707 "connection.c"
	}
	__finally8:
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_inner_error_ != NULL) {
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (stream);
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (dir);
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_object_unref0 (msg);
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_clear_error (&_inner_error_);
#line 341 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return FALSE;
#line 1724 "connection.c"
	}
#line 348 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	result = TRUE;
#line 348 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (stream);
#line 348 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (dir);
#line 348 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (msg);
#line 348 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (status) {
#line 348 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		*status = _vala_status;
#line 1738 "connection.c"
	} else {
#line 348 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		_g_free0 (_vala_status);
#line 1742 "connection.c"
	}
#line 348 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return result;
#line 1746 "connection.c"
}


static void diorite_connection_parse_libsoup_version (void) {
	gint _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	gchar** libsoup_version = NULL;
	const gchar* _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gint libsoup_version_length1 = 0;
	gint _libsoup_version_size_ = 0;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	const gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gchar** _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	const gchar* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gchar** _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	const gchar* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	gint _tmp14_[3] = {0};
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
#line 354 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = diorite_LIBSOUP_VERSION[0];
#line 354 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	if (_tmp0_ != 0) {
#line 354 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		return;
#line 1781 "connection.c"
	}
#line 355 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = g_strdup (LIBSOUP_2_4_VERSION);
#line 355 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_free0 (diorite_LIBSOUP_VERSION_STRING);
#line 355 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	diorite_LIBSOUP_VERSION_STRING = _tmp1_;
#line 356 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp2_ = diorite_LIBSOUP_VERSION_STRING;
#line 356 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ".", 0);
#line 356 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	libsoup_version = _tmp4_;
#line 356 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	libsoup_version_length1 = _vala_array_length (_tmp3_);
#line 356 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_libsoup_version_size_ = libsoup_version_length1;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp5_ = libsoup_version;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp5__length1 = libsoup_version_length1;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp6_ = _tmp5_[0];
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp7_ = atoi (_tmp6_);
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp8_ = libsoup_version;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp8__length1 = libsoup_version_length1;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp9_ = _tmp8_[1];
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp10_ = atoi (_tmp9_);
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp11_ = libsoup_version;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp11__length1 = libsoup_version_length1;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp12_ = _tmp11_[2];
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp13_ = atoi (_tmp12_);
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp14_[0] = _tmp7_;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp14_[1] = _tmp10_;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp14_[2] = _tmp13_;
#line 357 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	memcpy (diorite_LIBSOUP_VERSION, _tmp14_, 3 * sizeof (gint));
#line 362 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp15_ = diorite_LIBSOUP_VERSION[0];
#line 362 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp16_ = diorite_LIBSOUP_VERSION[1];
#line 362 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp17_ = diorite_LIBSOUP_VERSION[2];
#line 362 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	diorite_logger_lib_debug ("Libsoup version: %d.%d.%d", _tmp15_, _tmp16_, _tmp17_, NULL);
#line 351 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	libsoup_version = (_vala_array_free (libsoup_version, libsoup_version_length1, (GDestroyNotify) g_free), NULL);
#line 1841 "connection.c"
}


gchar* diorite_connection_libsoup_version_string (void) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 370 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	diorite_connection_parse_libsoup_version ();
#line 371 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = diorite_LIBSOUP_VERSION_STRING;
#line 371 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 371 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	result = _tmp1_;
#line 371 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return result;
#line 1859 "connection.c"
}


DioriteConnection* diorite_connection_construct (GType object_type) {
	DioriteConnection * self = NULL;
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	self = (DioriteConnection*) g_object_new (object_type, NULL);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return self;
#line 1869 "connection.c"
}


DioriteConnection* diorite_connection_new (void) {
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return diorite_connection_construct (DIORITE_TYPE_CONNECTION);
#line 1876 "connection.c"
}


SoupSession* diorite_connection_get_session (DioriteConnection* self) {
	SoupSession* result;
	SoupSession* _tmp0_ = NULL;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = self->priv->_session;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	result = _tmp0_;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	return result;
#line 1891 "connection.c"
}


static void diorite_connection_set_session (DioriteConnection* self, SoupSession* value) {
	SoupSession* _tmp0_ = NULL;
	SoupSession* _tmp1_ = NULL;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_return_if_fail (self != NULL);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp0_ = value;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (self->priv->_session);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	self->priv->_session = _tmp1_;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_object_notify ((GObject *) self, "session");
#line 1910 "connection.c"
}


static void diorite_connection_class_init (DioriteConnectionClass * klass) {
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	diorite_connection_parent_class = g_type_class_peek_parent (klass);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_type_class_add_private (klass, sizeof (DioriteConnectionPrivate));
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_diorite_connection_get_property;
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_diorite_connection_set_property;
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	G_OBJECT_CLASS (klass)->finalize = diorite_connection_finalize;
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_CONNECTION_SESSION, g_param_spec_object ("session", "session", "session", soup_session_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1927 "connection.c"
}


static void diorite_connection_instance_init (DioriteConnection * self) {
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	self->priv = DIORITE_CONNECTION_GET_PRIVATE (self);
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	self->priv->proxy_is_set = FALSE;
#line 1936 "connection.c"
}


static void diorite_connection_finalize (GObject* obj) {
	DioriteConnection * self;
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_CONNECTION, DioriteConnection);
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	diorite_connection_dump_cache (self);
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (self->priv->storage);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	_g_object_unref0 (self->priv->_session);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	G_OBJECT_CLASS (diorite_connection_parent_class)->finalize (obj);
#line 1952 "connection.c"
}


/**
 * Network connection and related settings including
 * proxy settings, cookies and cache
 */
GType diorite_connection_get_type (void) {
	static volatile gsize diorite_connection_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteConnection), 0, (GInstanceInitFunc) diorite_connection_instance_init, NULL };
		GType diorite_connection_type_id;
		diorite_connection_type_id = g_type_register_static (G_TYPE_OBJECT, "DioriteConnection", &g_define_type_info, 0);
		g_once_init_leave (&diorite_connection_type_id__volatile, diorite_connection_type_id);
	}
	return diorite_connection_type_id__volatile;
}


static void _vala_diorite_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioriteConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_CONNECTION, DioriteConnection);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	switch (property_id) {
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		case DIORITE_CONNECTION_SESSION:
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		g_value_set_object (value, diorite_connection_get_session (self));
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		break;
#line 1983 "connection.c"
		default:
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		break;
#line 1989 "connection.c"
	}
}


static void _vala_diorite_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioriteConnection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_CONNECTION, DioriteConnection);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
	switch (property_id) {
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		case DIORITE_CONNECTION_SESSION:
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		diorite_connection_set_session (self, g_value_get_object (value));
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		break;
#line 2005 "connection.c"
		default:
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/connection.vala"
		break;
#line 2011 "connection.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



