/* diorite-infobar.c generated by valac 0.22.1, the Vala compiler
 * generated from diorite-infobar.vala, do not modify */

/*
 * Copyright 2013 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define DIORITE_TYPE_INFO_BAR (diorite_info_bar_get_type ())
#define DIORITE_INFO_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_INFO_BAR, DioriteInfoBar))
#define DIORITE_INFO_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_INFO_BAR, DioriteInfoBarClass))
#define DIORITE_IS_INFO_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_INFO_BAR))
#define DIORITE_IS_INFO_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_INFO_BAR))
#define DIORITE_INFO_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_INFO_BAR, DioriteInfoBarClass))

typedef struct _DioriteInfoBar DioriteInfoBar;
typedef struct _DioriteInfoBarClass DioriteInfoBarClass;
typedef struct _DioriteInfoBarPrivate DioriteInfoBarPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DIORITE_TYPE_WRAPPED_LABEL (diorite_wrapped_label_get_type ())
#define DIORITE_WRAPPED_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_WRAPPED_LABEL, DioriteWrappedLabel))
#define DIORITE_WRAPPED_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_WRAPPED_LABEL, DioriteWrappedLabelClass))
#define DIORITE_IS_WRAPPED_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_WRAPPED_LABEL))
#define DIORITE_IS_WRAPPED_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_WRAPPED_LABEL))
#define DIORITE_WRAPPED_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_WRAPPED_LABEL, DioriteWrappedLabelClass))

typedef struct _DioriteWrappedLabel DioriteWrappedLabel;
typedef struct _DioriteWrappedLabelClass DioriteWrappedLabelClass;

struct _DioriteInfoBar {
	GtkGrid parent_instance;
	DioriteInfoBarPrivate * priv;
};

struct _DioriteInfoBarClass {
	GtkGridClass parent_class;
	void (*closed) (DioriteInfoBar* self);
};

struct _DioriteInfoBarPrivate {
	GtkLabel* _label;
	GtkButton* close_button;
	GtkGrid* button_box;
};


static gpointer diorite_info_bar_parent_class = NULL;

GType diorite_info_bar_get_type (void) G_GNUC_CONST;
#define DIORITE_INFO_BAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_INFO_BAR, DioriteInfoBarPrivate))
enum  {
	DIORITE_INFO_BAR_DUMMY_PROPERTY,
	DIORITE_INFO_BAR_LABEL
};
DioriteInfoBar* diorite_info_bar_new (const gchar* icon, const gchar* text, gboolean use_markup);
DioriteInfoBar* diorite_info_bar_construct (GType object_type, const gchar* icon, const gchar* text, gboolean use_markup);
DioriteWrappedLabel* diorite_wrapped_label_new (const gchar* label, gboolean use_markup);
DioriteWrappedLabel* diorite_wrapped_label_construct (GType object_type, const gchar* label, gboolean use_markup);
GType diorite_wrapped_label_get_type (void) G_GNUC_CONST;
static void diorite_info_bar_set_label (DioriteInfoBar* self, GtkLabel* value);
GtkLabel* diorite_info_bar_get_label (DioriteInfoBar* self);
static void diorite_info_bar_on_close_button_clicked (DioriteInfoBar* self);
static void _diorite_info_bar_on_close_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
DioriteInfoBar* diorite_info_bar_new_warning (const gchar* text, gboolean use_markup);
DioriteInfoBar* diorite_info_bar_construct_warning (GType object_type, const gchar* text, gboolean use_markup);
DioriteInfoBar* diorite_info_bar_new_info (const gchar* text, gboolean use_markup);
DioriteInfoBar* diorite_info_bar_construct_info (GType object_type, const gchar* text, gboolean use_markup);
DioriteInfoBar* diorite_info_bar_new_error (const gchar* text, gboolean use_markup);
DioriteInfoBar* diorite_info_bar_construct_error (GType object_type, const gchar* text, gboolean use_markup);
void diorite_info_bar_add_button (DioriteInfoBar* self, GtkButton* button);
static void diorite_info_bar_real_closed (DioriteInfoBar* self);
static void diorite_info_bar_finalize (GObject* obj);
static void _vala_diorite_info_bar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diorite_info_bar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Creates new InfoBar.
 * 
 * @param icon          icon show on the left
 * @param text          text of the information
 * @param use_markup    whether to use Pango markup for the text
 */
static void _diorite_info_bar_on_close_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	diorite_info_bar_on_close_button_clicked (self);
#line 115 "diorite-infobar.c"
}


DioriteInfoBar* diorite_info_bar_construct (GType object_type, const gchar* icon, const gchar* text, gboolean use_markup) {
	DioriteInfoBar * self = NULL;
	GtkImage* icon_image = NULL;
	const gchar* _tmp0_ = NULL;
	GtkImage* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	DioriteWrappedLabel* _tmp4_ = NULL;
	DioriteWrappedLabel* _tmp5_ = NULL;
	GtkLabel* _tmp6_ = NULL;
	GtkLabel* _tmp7_ = NULL;
	GtkLabel* _tmp8_ = NULL;
	GtkLabel* _tmp9_ = NULL;
	GtkButton* _tmp10_ = NULL;
	GtkButton* _tmp11_ = NULL;
	GtkImage* _tmp12_ = NULL;
	GtkImage* _tmp13_ = NULL;
	GtkButton* _tmp14_ = NULL;
	GtkGrid* _tmp15_ = NULL;
	GtkGrid* _tmp16_ = NULL;
	GtkGrid* _tmp17_ = NULL;
	GtkGrid* _tmp18_ = NULL;
	GtkButton* _tmp19_ = NULL;
	GtkGrid* _tmp20_ = NULL;
	GtkGrid* _tmp21_ = NULL;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	self = (DioriteInfoBar*) g_object_new (object_type, NULL);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp0_ = icon;
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_stock (_tmp0_, GTK_ICON_SIZE_BUTTON);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_ref_sink (_tmp1_);
#line 48 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	icon_image = _tmp1_;
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_widget_set_halign ((GtkWidget*) icon_image, GTK_ALIGN_CENTER);
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_widget_set_valign ((GtkWidget*) icon_image, GTK_ALIGN_CENTER);
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_set ((GtkWidget*) icon_image, "margin", 5, NULL);
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_widget_show ((GtkWidget*) icon_image);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) icon_image);
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp2_ = text;
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp3_ = use_markup;
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp4_ = diorite_wrapped_label_new (_tmp2_, _tmp3_);
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_ref_sink (_tmp4_);
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp5_ = _tmp4_;
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	diorite_info_bar_set_label (self, (GtkLabel*) _tmp5_);
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (_tmp5_);
#line 56 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp6_ = self->priv->_label;
#line 56 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_set ((GtkMisc*) _tmp6_, "xpad", 10, NULL);
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp7_ = self->priv->_label;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_set ((GtkMisc*) _tmp7_, "ypad", 5, NULL);
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp8_ = self->priv->_label;
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_widget_show ((GtkWidget*) _tmp8_);
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp9_ = self->priv->_label;
#line 59 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp9_);
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp10_ = (GtkButton*) gtk_button_new ();
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_ref_sink (_tmp10_);
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (self->priv->close_button);
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	self->priv->close_button = _tmp10_;
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp11_ = self->priv->close_button;
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp12_ = (GtkImage*) gtk_image_new_from_stock (GTK_STOCK_CLOSE, GTK_ICON_SIZE_BUTTON);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_ref_sink (_tmp12_);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp13_ = _tmp12_;
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp13_);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (_tmp13_);
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp14_ = self->priv->close_button;
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_signal_connect_object (_tmp14_, "clicked", (GCallback) _diorite_info_bar_on_close_button_clicked_gtk_button_clicked, self, 0);
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp15_ = (GtkGrid*) gtk_grid_new ();
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_ref_sink (_tmp15_);
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (self->priv->button_box);
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	self->priv->button_box = _tmp15_;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp16_ = self->priv->button_box;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_set ((GtkWidget*) _tmp16_, "expand", FALSE, NULL);
#line 67 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp17_ = self->priv->button_box;
#line 67 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_CENTER);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp18_ = self->priv->button_box;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp19_ = self->priv->close_button;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp20_ = self->priv->button_box;
#line 69 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp20_);
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp21_ = self->priv->button_box;
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp21_);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (icon_image);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return self;
#line 256 "diorite-infobar.c"
}


DioriteInfoBar* diorite_info_bar_new (const gchar* icon, const gchar* text, gboolean use_markup) {
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return diorite_info_bar_construct (DIORITE_TYPE_INFO_BAR, icon, text, use_markup);
#line 263 "diorite-infobar.c"
}


/**
 * Creates new InfoBar with warning icon.
 * 
 * @param text          text of the warning
 * @param use_markup    whether to use Pango markup for the text
 */
DioriteInfoBar* diorite_info_bar_construct_warning (GType object_type, const gchar* text, gboolean use_markup) {
	DioriteInfoBar * self = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp0_ = text;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp1_ = use_markup;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	self = (DioriteInfoBar*) diorite_info_bar_construct (object_type, GTK_STOCK_DIALOG_WARNING, _tmp0_, _tmp1_);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return self;
#line 287 "diorite-infobar.c"
}


DioriteInfoBar* diorite_info_bar_new_warning (const gchar* text, gboolean use_markup) {
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return diorite_info_bar_construct_warning (DIORITE_TYPE_INFO_BAR, text, use_markup);
#line 294 "diorite-infobar.c"
}


/**
 * Creates new InfoBar with information icon.
 * 
 * @param text          text of the information
 * @param use_markup    whether to use Pango markup for the text
 */
DioriteInfoBar* diorite_info_bar_construct_info (GType object_type, const gchar* text, gboolean use_markup) {
	DioriteInfoBar * self = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp0_ = text;
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp1_ = use_markup;
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	self = (DioriteInfoBar*) diorite_info_bar_construct (object_type, GTK_STOCK_DIALOG_INFO, _tmp0_, _tmp1_);
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return self;
#line 318 "diorite-infobar.c"
}


DioriteInfoBar* diorite_info_bar_new_info (const gchar* text, gboolean use_markup) {
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return diorite_info_bar_construct_info (DIORITE_TYPE_INFO_BAR, text, use_markup);
#line 325 "diorite-infobar.c"
}


/**
 * Creates new InfoBar with error icon.
 * 
 * @param text          text of the error
 * @param use_markup    whether to use Pango markup for the text
 */
DioriteInfoBar* diorite_info_bar_construct_error (GType object_type, const gchar* text, gboolean use_markup) {
	DioriteInfoBar * self = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp0_ = text;
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp1_ = use_markup;
#line 103 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	self = (DioriteInfoBar*) diorite_info_bar_construct (object_type, GTK_STOCK_DIALOG_ERROR, _tmp0_, _tmp1_);
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return self;
#line 349 "diorite-infobar.c"
}


DioriteInfoBar* diorite_info_bar_new_error (const gchar* text, gboolean use_markup) {
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return diorite_info_bar_construct_error (DIORITE_TYPE_INFO_BAR, text, use_markup);
#line 356 "diorite-infobar.c"
}


/**
 * Adds button to info bar
 * @param button    button to add
 */
void diorite_info_bar_add_button (DioriteInfoBar* self, GtkButton* button) {
	GtkGrid* _tmp0_ = NULL;
	GtkButton* _tmp1_ = NULL;
	GtkGrid* _tmp2_ = NULL;
	GtkButton* _tmp3_ = NULL;
	GtkGrid* _tmp4_ = NULL;
	GtkButton* _tmp5_ = NULL;
	GtkButton* _tmp6_ = NULL;
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_if_fail (self != NULL);
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_if_fail (button != NULL);
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp0_ = self->priv->button_box;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp1_ = self->priv->close_button;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_container_remove ((GtkContainer*) _tmp0_, (GtkWidget*) _tmp1_);
#line 123 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp2_ = self->priv->button_box;
#line 123 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp3_ = button;
#line 123 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_container_add ((GtkContainer*) _tmp2_, (GtkWidget*) _tmp3_);
#line 124 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp4_ = self->priv->button_box;
#line 124 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp5_ = self->priv->close_button;
#line 124 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp6_ = button;
#line 125 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	gtk_widget_show ((GtkWidget*) _tmp6_);
#line 398 "diorite-infobar.c"
}


static void diorite_info_bar_on_close_button_clicked (DioriteInfoBar* self) {
#line 129 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_if_fail (self != NULL);
#line 131 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_signal_emit_by_name (self, "closed");
#line 407 "diorite-infobar.c"
}


GtkLabel* diorite_info_bar_get_label (DioriteInfoBar* self) {
	GtkLabel* result;
	GtkLabel* _tmp0_ = NULL;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp0_ = self->priv->_label;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return result;
#line 422 "diorite-infobar.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	return self ? g_object_ref (self) : NULL;
#line 429 "diorite-infobar.c"
}


static void diorite_info_bar_set_label (DioriteInfoBar* self, GtkLabel* value) {
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp0_ = value;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (self->priv->_label);
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	self->priv->_label = _tmp1_;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_notify ((GObject *) self, "label");
#line 448 "diorite-infobar.c"
}


static void diorite_info_bar_real_closed (DioriteInfoBar* self) {
	GtkContainer* parent = NULL;
	GtkWidget* _tmp0_ = NULL;
	GtkContainer* _tmp1_ = NULL;
	GtkContainer* _tmp2_ = NULL;
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GTK_TYPE_CONTAINER) ? ((GtkContainer*) _tmp0_) : NULL);
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	parent = _tmp1_;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_tmp2_ = parent;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	if (_tmp2_ != NULL) {
#line 467 "diorite-infobar.c"
		GtkContainer* _tmp3_ = NULL;
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		_tmp3_ = parent;
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		gtk_container_remove (_tmp3_, (GtkWidget*) self);
#line 473 "diorite-infobar.c"
	}
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (parent);
#line 477 "diorite-infobar.c"
}


static void diorite_info_bar_class_init (DioriteInfoBarClass * klass) {
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	diorite_info_bar_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_type_class_add_private (klass, sizeof (DioriteInfoBarPrivate));
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	DIORITE_INFO_BAR_CLASS (klass)->closed = diorite_info_bar_real_closed;
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_diorite_info_bar_get_property;
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_diorite_info_bar_set_property;
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	G_OBJECT_CLASS (klass)->finalize = diorite_info_bar_finalize;
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_INFO_BAR_LABEL, g_param_spec_object ("label", "Text label", "Label containing text of the InfoBar.", GTK_TYPE_LABEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 496 "diorite-infobar.c"
	/**
	 * Emitted when the info bar is closed.
	 */
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	g_signal_new ("closed", DIORITE_TYPE_INFO_BAR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DioriteInfoBarClass, closed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 502 "diorite-infobar.c"
}


static void diorite_info_bar_instance_init (DioriteInfoBar * self) {
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	self->priv = DIORITE_INFO_BAR_GET_PRIVATE (self);
#line 509 "diorite-infobar.c"
}


static void diorite_info_bar_finalize (GObject* obj) {
	DioriteInfoBar * self;
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_INFO_BAR, DioriteInfoBar);
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (self->priv->_label);
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (self->priv->close_button);
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	_g_object_unref0 (self->priv->button_box);
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	G_OBJECT_CLASS (diorite_info_bar_parent_class)->finalize (obj);
#line 525 "diorite-infobar.c"
}


/**
 * InfoBar is a bar designed to show short information.
 */
GType diorite_info_bar_get_type (void) {
	static volatile gsize diorite_info_bar_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_info_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteInfoBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_info_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteInfoBar), 0, (GInstanceInitFunc) diorite_info_bar_instance_init, NULL };
		GType diorite_info_bar_type_id;
		diorite_info_bar_type_id = g_type_register_static (GTK_TYPE_GRID, "DioriteInfoBar", &g_define_type_info, 0);
		g_once_init_leave (&diorite_info_bar_type_id__volatile, diorite_info_bar_type_id);
	}
	return diorite_info_bar_type_id__volatile;
}


static void _vala_diorite_info_bar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioriteInfoBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_INFO_BAR, DioriteInfoBar);
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	switch (property_id) {
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		case DIORITE_INFO_BAR_LABEL:
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		g_value_set_object (value, diorite_info_bar_get_label (self));
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		break;
#line 555 "diorite-infobar.c"
		default:
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		break;
#line 561 "diorite-infobar.c"
	}
}


static void _vala_diorite_info_bar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioriteInfoBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_INFO_BAR, DioriteInfoBar);
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
	switch (property_id) {
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		case DIORITE_INFO_BAR_LABEL:
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		diorite_info_bar_set_label (self, g_value_get_object (value));
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		break;
#line 577 "diorite-infobar.c"
		default:
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-infobar.vala"
		break;
#line 583 "diorite-infobar.c"
	}
}



