/* diorite-wrappedlabel.c generated by valac 0.22.1, the Vala compiler
 * generated from diorite-wrappedlabel.vala, do not modify */

/*
 * Copyright 2013 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>


#define DIORITE_TYPE_WRAPPED_LABEL (diorite_wrapped_label_get_type ())
#define DIORITE_WRAPPED_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_WRAPPED_LABEL, DioriteWrappedLabel))
#define DIORITE_WRAPPED_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_WRAPPED_LABEL, DioriteWrappedLabelClass))
#define DIORITE_IS_WRAPPED_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_WRAPPED_LABEL))
#define DIORITE_IS_WRAPPED_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_WRAPPED_LABEL))
#define DIORITE_WRAPPED_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_WRAPPED_LABEL, DioriteWrappedLabelClass))

typedef struct _DioriteWrappedLabel DioriteWrappedLabel;
typedef struct _DioriteWrappedLabelClass DioriteWrappedLabelClass;
typedef struct _DioriteWrappedLabelPrivate DioriteWrappedLabelPrivate;

struct _DioriteWrappedLabel {
	GtkLabel parent_instance;
	DioriteWrappedLabelPrivate * priv;
};

struct _DioriteWrappedLabelClass {
	GtkLabelClass parent_class;
};


static gpointer diorite_wrapped_label_parent_class = NULL;

GType diorite_wrapped_label_get_type (void) G_GNUC_CONST;
enum  {
	DIORITE_WRAPPED_LABEL_DUMMY_PROPERTY
};
DioriteWrappedLabel* diorite_wrapped_label_new (const gchar* label, gboolean use_markup);
DioriteWrappedLabel* diorite_wrapped_label_construct (GType object_type, const gchar* label, gboolean use_markup);


/**
 * Creates new WrappedLabel
 *
 * @param label         text of the label
 * @param use_markup    whether to use Pango Markup
 */
DioriteWrappedLabel* diorite_wrapped_label_construct (GType object_type, const gchar* label, gboolean use_markup) {
	DioriteWrappedLabel * self = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-wrappedlabel.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-wrappedlabel.vala"
	_tmp0_ = label;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-wrappedlabel.vala"
	_tmp1_ = use_markup;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-wrappedlabel.vala"
	self = (DioriteWrappedLabel*) g_object_new (object_type, "label", _tmp0_, "use-markup", _tmp1_, "selectable", TRUE, "can-focus", FALSE, "xalign", 0.0f, "yalign", 0.5f, "wrap-mode", PANGO_WRAP_WORD, "justify", GTK_JUSTIFY_FILL, "vexpand", FALSE, "hexpand", TRUE, NULL);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-wrappedlabel.vala"
	gtk_label_set_line_wrap ((GtkLabel*) self, TRUE);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-wrappedlabel.vala"
	gtk_label_set_max_width_chars ((GtkLabel*) self, 5);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-wrappedlabel.vala"
	return self;
#line 92 "diorite-wrappedlabel.c"
}


DioriteWrappedLabel* diorite_wrapped_label_new (const gchar* label, gboolean use_markup) {
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-wrappedlabel.vala"
	return diorite_wrapped_label_construct (DIORITE_TYPE_WRAPPED_LABEL, label, use_markup);
#line 99 "diorite-wrappedlabel.c"
}


static void diorite_wrapped_label_class_init (DioriteWrappedLabelClass * klass) {
#line 31 "/builddir/build/BUILD/nuvolaplayer-2.5/src/diorite/diorite-wrappedlabel.vala"
	diorite_wrapped_label_parent_class = g_type_class_peek_parent (klass);
#line 106 "diorite-wrappedlabel.c"
}


static void diorite_wrapped_label_instance_init (DioriteWrappedLabel * self) {
}


/**
 * Label with wrapped lines.
 */
GType diorite_wrapped_label_get_type (void) {
	static volatile gsize diorite_wrapped_label_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_wrapped_label_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteWrappedLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_wrapped_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteWrappedLabel), 0, (GInstanceInitFunc) diorite_wrapped_label_instance_init, NULL };
		GType diorite_wrapped_label_type_id;
		diorite_wrapped_label_type_id = g_type_register_static (GTK_TYPE_LABEL, "DioriteWrappedLabel", &g_define_type_info, 0);
		g_once_init_leave (&diorite_wrapped_label_type_id__volatile, diorite_wrapped_label_type_id);
	}
	return diorite_wrapped_label_type_id__volatile;
}



