/* jstools.c generated by valac 0.22.1, the Vala compiler
 * generated from jstools.vala, do not modify */

/*
 * Copyright 2011-2013 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <JavaScriptCore/JavaScript.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _JSStringRelease0(var) ((var == NULL) ? NULL : (var = (JSStringRelease (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))



gchar* nuvola_js_tools_utf8_string (void* jsstring);
void* nuvola_js_tools_object_from_JSON (void* ctx, const gchar* json);
void* nuvola_js_tools_create_exception (void* ctx, const gchar* message);
gchar* nuvola_js_tools_o_get_string (void* ctx, void* obj, const gchar* property);
gdouble nuvola_js_tools_o_get_number (void* ctx, void* obj, const gchar* property);
void nuvola_js_tools_o_set_string (void* ctx, void* obj, const gchar* property, const gchar* value);
void nuvola_js_tools_o_set_number (void* ctx, void* obj, const gchar* property, gdouble value);
void nuvola_js_tools_o_set_bool (void* ctx, void* obj, const gchar* property, gboolean value);
void* nuvola_js_tools_o_get_object (void* ctx, void* obj, const gchar* property);
gchar* nuvola_js_tools_string_or_null (void* ctx, void* val, gboolean allow_empty);
gchar* nuvola_js_tools_value_to_string (void* ctx, void* value);
gchar* nuvola_js_tools_exception_to_string (void* ctx, void* value);
void* nuvola_js_tools_get_gobject_property_named (void* ctx, GObject* o, const gchar* name);
void* nuvola_js_tools_get_gobject_property (void* ctx, GObject* o, GParamSpec* p);


/**
 * Converts JavaScriptCore string to Vala UTF-8 string
 *
 * @param jsstring JavaScriptCore string
 * @return Vala UTF-8 string
 */
gchar* nuvola_js_tools_utf8_string (void* jsstring) {
	gchar* result = NULL;
	gchar* str = NULL;
	void* _tmp0_ = NULL;
	gsize _tmp1_ = 0UL;
	gchar* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (jsstring != NULL, NULL);
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = jsstring;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = JSStringGetMaximumUTF8CStringSize (_tmp0_);
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = g_strnfill (_tmp1_, ' ');
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	str = _tmp2_;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = jsstring;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = strlen (str);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = _tmp4_;
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	JSStringGetUTF8CString (_tmp3_, str, (gsize) _tmp5_);
#line 40 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = str;
#line 40 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 98 "jstools.c"
}


/**
 * Creates JavaScript object from JSON.
 * 
 * @param ctx	JavaScript context
 * @param json	object in JSON notation
 * @return	JavaScript object
 */
void* nuvola_js_tools_object_from_JSON (void* ctx, const gchar* json) {
	void* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	void* _result_ = NULL;
	void* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	void* _tmp6_ = NULL;
	void* _tmp7_ = NULL;
	void* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	void* _tmp10_ = NULL;
	gboolean _tmp14_ = FALSE;
	void* _tmp17_ = NULL;
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, NULL);
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (json != NULL, NULL);
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = json;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (g_strcmp0 (_tmp1_, "") == 0) {
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp0_ = "{}";
#line 134 "jstools.c"
	} else {
		const gchar* _tmp2_ = NULL;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp2_ = json;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp0_ = _tmp2_;
#line 141 "jstools.c"
	}
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = ctx;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = _tmp0_;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = JSStringCreateWithUTF8CString (_tmp4_);
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp6_ = _tmp5_;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp7_ = JSValueMakeFromJSONString (_tmp3_, _tmp6_);
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp8_ = _tmp7_;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_JSStringRelease0 (_tmp6_);
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_result_ = _tmp8_;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp10_ = _result_;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp10_ == NULL) {
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp9_ = TRUE;
#line 165 "jstools.c"
	} else {
		void* _tmp11_ = NULL;
		void* _tmp12_ = NULL;
		gboolean _tmp13_ = FALSE;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp11_ = _result_;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp12_ = ctx;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp13_ = JSValueIsObject (_tmp12_, _tmp11_);
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp9_ = !_tmp13_;
#line 178 "jstools.c"
	}
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp14_ = _tmp9_;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp14_) {
#line 184 "jstools.c"
		void* _tmp15_ = NULL;
		void* _tmp16_ = NULL;
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp15_ = ctx;
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp16_ = JSObjectMake (_tmp15_, NULL, NULL);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_result_ = _tmp16_;
#line 193 "jstools.c"
	}
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp17_ = _result_;
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = _tmp17_;
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 201 "jstools.c"
}


/**
 * Creates JavaScript Exception object.
 * 
 * @param ctx	JavaScript context
 * @param message	Error message (single line);
 * @return	JavaScript object
 */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1241 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1241 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1241 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 221 "jstools.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp0_ = old;
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		regex = _tmp4_;
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 251 "jstools.c"
				goto __catch38_g_regex_error;
			}
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1243 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			return NULL;
#line 260 "jstools.c"
		}
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 276 "jstools.c"
				goto __catch38_g_regex_error;
			}
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
			return NULL;
#line 287 "jstools.c"
		}
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		result = _tmp5_;
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1244 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		return result;
#line 295 "jstools.c"
	}
	goto __finally38;
	__catch38_g_regex_error:
	{
		GError* e = NULL;
#line 1242 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		e = _inner_error_;
#line 1242 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1246 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1242 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_g_error_free0 (e);
#line 309 "jstools.c"
	}
	__finally38:
#line 1242 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1242 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1242 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1242 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		return NULL;
#line 320 "jstools.c"
	}
}


void* nuvola_js_tools_create_exception (void* ctx, const gchar* message) {
	void* result = NULL;
	gchar* exception = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	void* _tmp6_ = NULL;
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, NULL);
#line 65 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = message;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = string_replace (_tmp0_, "\"", "\\\"");
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = _tmp1_;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = g_strdup_printf ("{\"type\":\"NuvolaError\", \"message\":\"%s\"}", _tmp2_);
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = _tmp3_;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_g_free0 (_tmp2_);
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	exception = _tmp4_;
#line 67 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_debug ("jstools.vala:67: %s", exception);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = ctx;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp6_ = nuvola_js_tools_object_from_JSON (_tmp5_, exception);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = _tmp6_;
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_g_free0 (exception);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 365 "jstools.c"
}


/**
 * Obtains string property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return string value or null if property is not a string
 */
gchar* nuvola_js_tools_o_get_string (void* ctx, void* obj, const gchar* property) {
	gchar* result = NULL;
	void* value = NULL;
	void* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	void* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	void* _tmp6_ = NULL;
	void* _tmp7_ = NULL;
	void* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, NULL);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (property != NULL, NULL);
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = obj;
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = ctx;
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = property;
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = _tmp3_;
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = JSObjectGetProperty (_tmp1_, _tmp0_, _tmp4_, NULL);
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp6_ = _tmp5_;
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_JSStringRelease0 (_tmp4_);
#line 80 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	value = _tmp6_;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp7_ = value;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp8_ = ctx;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp9_ = JSValueIsString (_tmp8_, _tmp7_);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp9_) {
#line 422 "jstools.c"
		void* _tmp10_ = NULL;
		void* _tmp11_ = NULL;
		void* _tmp12_ = NULL;
		void* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp10_ = value;
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp11_ = ctx;
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp12_ = JSValueToStringCopy (_tmp11_, _tmp10_, NULL);
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp13_ = _tmp12_;
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp14_ = nuvola_js_tools_utf8_string (_tmp13_);
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp15_ = _tmp14_;
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_JSStringRelease0 (_tmp13_);
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp15_;
#line 82 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 447 "jstools.c"
	}
#line 84 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = NULL;
#line 84 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 453 "jstools.c"
}


/**
 * Obtains number property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return double value or 0.0 if property is not a number
 */
gdouble nuvola_js_tools_o_get_number (void* ctx, void* obj, const gchar* property) {
	gdouble result = 0.0;
	void* value = NULL;
	void* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	void* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	void* _tmp6_ = NULL;
	void* _tmp7_ = NULL;
	void* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, 0.0);
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (obj != NULL, 0.0);
#line 95 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (property != NULL, 0.0);
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = obj;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = ctx;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = property;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = _tmp3_;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = JSObjectGetProperty (_tmp1_, _tmp0_, _tmp4_, NULL);
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp6_ = _tmp5_;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_JSStringRelease0 (_tmp4_);
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	value = _tmp6_;
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp7_ = value;
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp8_ = ctx;
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp9_ = JSValueIsNumber (_tmp8_, _tmp7_);
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp9_) {
#line 510 "jstools.c"
		void* _tmp10_ = NULL;
		void* _tmp11_ = NULL;
		gdouble _tmp12_ = 0.0;
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp10_ = value;
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp11_ = ctx;
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp12_ = JSValueToNumber (_tmp11_, _tmp10_, NULL);
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp12_;
#line 98 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 524 "jstools.c"
	}
#line 100 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = 0.0;
#line 100 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 530 "jstools.c"
}


/**
 * Sets string property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void nuvola_js_tools_o_set_string (void* ctx, void* obj, const gchar* property, const gchar* value) {
	void* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	void* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	void* _tmp7_ = NULL;
	void* _tmp8_ = NULL;
	void* _tmp9_ = NULL;
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (ctx != NULL);
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (obj != NULL);
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (property != NULL);
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (value != NULL);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = obj;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = ctx;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = property;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = _tmp3_;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = ctx;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp6_ = value;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp7_ = JSStringCreateWithUTF8CString (_tmp6_);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp8_ = _tmp7_;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp9_ = JSValueMakeString (_tmp5_, _tmp8_);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp9_, 0, NULL);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_JSStringRelease0 (_tmp8_);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_JSStringRelease0 (_tmp4_);
#line 587 "jstools.c"
}


/**
 * Sets string property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void nuvola_js_tools_o_set_number (void* ctx, void* obj, const gchar* property, gdouble value) {
	void* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	void* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	gdouble _tmp6_ = 0.0;
	void* _tmp7_ = NULL;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (ctx != NULL);
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (obj != NULL);
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (property != NULL);
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = obj;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = ctx;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = property;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = _tmp3_;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = ctx;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp6_ = value;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp7_ = JSValueMakeNumber (_tmp5_, _tmp6_);
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp7_, 0, NULL);
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_JSStringRelease0 (_tmp4_);
#line 634 "jstools.c"
}


/**
 * Sets boolean property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @param value property value
 */
void nuvola_js_tools_o_set_bool (void* ctx, void* obj, const gchar* property, gboolean value) {
	void* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	void* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	void* _tmp7_ = NULL;
#line 141 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (ctx != NULL);
#line 141 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (obj != NULL);
#line 141 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_if_fail (property != NULL);
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = obj;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = ctx;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = property;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = _tmp3_;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = ctx;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp6_ = value;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp7_ = JSValueMakeBoolean (_tmp5_, _tmp6_);
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	JSObjectSetProperty (_tmp1_, _tmp0_, _tmp4_, _tmp7_, 0, NULL);
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_JSStringRelease0 (_tmp4_);
#line 681 "jstools.c"
}


/**
 * Obtains object property of JavaScript object
 * 
 * @param ctx JavaScript context
 * @param obj JavaScript object
 * @param property property name
 * @return object or null if property is not a object
 */
void* nuvola_js_tools_o_get_object (void* ctx, void* obj, const gchar* property) {
	void* result = NULL;
	void* value = NULL;
	void* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	void* _tmp3_ = NULL;
	void* _tmp4_ = NULL;
	void* _tmp5_ = NULL;
	void* _tmp6_ = NULL;
	void* _tmp7_ = NULL;
	void* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, NULL);
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (property != NULL, NULL);
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = obj;
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = ctx;
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = property;
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = JSStringCreateWithUTF8CString (_tmp2_);
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = _tmp3_;
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = JSObjectGetProperty (_tmp1_, _tmp0_, _tmp4_, NULL);
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp6_ = _tmp5_;
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_JSStringRelease0 (_tmp4_);
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	value = _tmp6_;
#line 158 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp7_ = value;
#line 158 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp8_ = ctx;
#line 158 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp9_ = JSValueIsObject (_tmp8_, _tmp7_);
#line 158 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp9_) {
#line 738 "jstools.c"
		void* _tmp10_ = NULL;
		void* _tmp11_ = NULL;
		void* _tmp12_ = NULL;
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp10_ = value;
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp11_ = ctx;
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp12_ = JSValueToObject (_tmp11_, _tmp10_, NULL);
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp12_;
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 752 "jstools.c"
	}
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = NULL;
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 758 "jstools.c"
}


/**
 * Converts JavaScript value to string
 * 
 * @param ctx            JavaScript context
 * @param val            JavaScript value
 * @param allow_empty    if false null will be returned for empty string
 * @return string value or null if value is not a string
 */
gchar* nuvola_js_tools_string_or_null (void* ctx, void* val, gboolean allow_empty) {
	gchar* result = NULL;
	void* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 172 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, NULL);
#line 172 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (val != NULL, NULL);
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = val;
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = ctx;
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = JSValueIsString (_tmp1_, _tmp0_);
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp2_) {
#line 787 "jstools.c"
		gchar* str = NULL;
		void* _tmp3_ = NULL;
		void* _tmp4_ = NULL;
		void* _tmp5_ = NULL;
		void* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_ = NULL;
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp3_ = val;
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp4_ = ctx;
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp5_ = JSValueToStringCopy (_tmp4_, _tmp3_, NULL);
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp6_ = _tmp5_;
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp7_ = nuvola_js_tools_utf8_string (_tmp6_);
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp8_ = _tmp7_;
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_JSStringRelease0 (_tmp6_);
#line 174 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		str = _tmp8_;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp11_ = str;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		if (g_strcmp0 (_tmp11_, "") == 0) {
#line 821 "jstools.c"
			gboolean _tmp12_ = FALSE;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp12_ = allow_empty;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp10_ = !_tmp12_;
#line 827 "jstools.c"
		} else {
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp10_ = FALSE;
#line 831 "jstools.c"
		}
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp13_ = _tmp10_;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		if (_tmp13_) {
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp9_ = NULL;
#line 839 "jstools.c"
		} else {
			const gchar* _tmp14_ = NULL;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp14_ = str;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp9_ = _tmp14_;
#line 846 "jstools.c"
		}
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp15_ = _tmp9_;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp16_ = g_strdup (_tmp15_);
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp16_;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_g_free0 (str);
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 858 "jstools.c"
	}
#line 177 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = NULL;
#line 177 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 864 "jstools.c"
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
#line 781 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 781 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 781 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 781 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 781 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 781 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 781 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 781 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	result = _tmp4_;
#line 781 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	return result;
#line 894 "jstools.c"
}


gchar* nuvola_js_tools_value_to_string (void* ctx, void* value) {
	gchar* result = NULL;
	void* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	void* _tmp9_ = NULL;
	void* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	void* _tmp16_ = NULL;
	void* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, NULL);
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = value;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = ctx;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = JSValueIsString (_tmp1_, _tmp0_);
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp2_) {
#line 921 "jstools.c"
		void* _tmp3_ = NULL;
		void* _tmp4_ = NULL;
		void* _tmp5_ = NULL;
		void* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp3_ = value;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp4_ = ctx;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp5_ = JSValueToStringCopy (_tmp4_, _tmp3_, NULL);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp6_ = _tmp5_;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp7_ = nuvola_js_tools_utf8_string (_tmp6_);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp8_ = _tmp7_;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_JSStringRelease0 (_tmp6_);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp8_;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 946 "jstools.c"
	}
#line 184 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp9_ = value;
#line 184 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp10_ = ctx;
#line 184 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp11_ = JSValueIsNumber (_tmp10_, _tmp9_);
#line 184 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp11_) {
#line 956 "jstools.c"
		void* _tmp12_ = NULL;
		void* _tmp13_ = NULL;
		gdouble _tmp14_ = 0.0;
		gchar* _tmp15_ = NULL;
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp12_ = value;
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp13_ = ctx;
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp14_ = JSValueToNumber (_tmp13_, _tmp12_, NULL);
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp15_ = double_to_string (_tmp14_);
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp15_;
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 973 "jstools.c"
	}
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp16_ = value;
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp17_ = ctx;
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp18_ = JSValueIsObject (_tmp17_, _tmp16_);
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp18_) {
#line 983 "jstools.c"
		void* _tmp19_ = NULL;
		void* _tmp20_ = NULL;
		void* _tmp21_ = NULL;
		void* _tmp22_ = NULL;
		void* _tmp23_ = NULL;
		void* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp19_ = value;
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp20_ = ctx;
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp21_ = JSValueToObject (_tmp20_, _tmp19_, NULL);
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp22_ = ctx;
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp23_ = JSValueCreateJSONString (_tmp22_, _tmp21_, (guint) 0, NULL);
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp24_ = _tmp23_;
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp25_ = nuvola_js_tools_utf8_string (_tmp24_);
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp26_ = _tmp25_;
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_JSStringRelease0 (_tmp24_);
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp26_;
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 1014 "jstools.c"
	}
#line 190 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = NULL;
#line 190 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 1020 "jstools.c"
}


gchar* nuvola_js_tools_exception_to_string (void* ctx, void* value) {
	gchar* result = NULL;
	void* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	void* _tmp46_ = NULL;
	void* _tmp47_ = NULL;
	gchar* _tmp48_ = NULL;
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, NULL);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = value;
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = ctx;
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = JSValueIsObject (_tmp1_, _tmp0_);
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp2_) {
#line 1044 "jstools.c"
		void* obj = NULL;
		void* _tmp3_ = NULL;
		void* _tmp4_ = NULL;
		void* _tmp5_ = NULL;
		gchar* message = NULL;
		void* _tmp6_ = NULL;
		void* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp3_ = value;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp4_ = ctx;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp5_ = JSValueToObject (_tmp4_, _tmp3_, NULL);
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		obj = _tmp5_;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp6_ = ctx;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp7_ = obj;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp8_ = nuvola_js_tools_o_get_string (_tmp6_, _tmp7_, "message");
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		message = _tmp8_;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp9_ = message;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		if (_tmp9_ != NULL) {
#line 1074 "jstools.c"
			gchar* name = NULL;
			void* _tmp10_ = NULL;
			void* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			gint line = 0;
			void* _tmp13_ = NULL;
			void* _tmp14_ = NULL;
			gdouble _tmp15_ = 0.0;
			gchar* file = NULL;
			void* _tmp16_ = NULL;
			void* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_ = 0;
			gboolean _tmp22_ = FALSE;
			gchar* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			gchar* _tmp33_ = NULL;
			const gchar* _tmp34_ = NULL;
			gchar* _tmp36_ = NULL;
			const gchar* _tmp37_ = NULL;
			gchar* _tmp38_ = NULL;
			const gchar* _tmp39_ = NULL;
			const gchar* _tmp41_ = NULL;
			gint _tmp42_ = 0;
			const gchar* _tmp43_ = NULL;
			const gchar* _tmp44_ = NULL;
			gchar* _tmp45_ = NULL;
#line 198 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp10_ = ctx;
#line 198 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp11_ = obj;
#line 198 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp12_ = nuvola_js_tools_o_get_string (_tmp10_, _tmp11_, "name");
#line 198 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			name = _tmp12_;
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp13_ = ctx;
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp14_ = obj;
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp15_ = nuvola_js_tools_o_get_number (_tmp13_, _tmp14_, "line");
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			line = (gint) _tmp15_;
#line 200 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp16_ = ctx;
#line 200 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp17_ = obj;
#line 200 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp18_ = nuvola_js_tools_o_get_string (_tmp16_, _tmp17_, "sourceURL");
#line 200 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			file = _tmp18_;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp20_ = line;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			if (_tmp20_ == 0) {
#line 1131 "jstools.c"
				const gchar* _tmp21_ = NULL;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp21_ = file;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp19_ = _tmp21_ == NULL;
#line 1137 "jstools.c"
			} else {
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp19_ = FALSE;
#line 1141 "jstools.c"
			}
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp22_ = _tmp19_;
#line 201 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			if (_tmp22_) {
#line 1147 "jstools.c"
				gchar* _tmp23_ = NULL;
				const gchar* _tmp24_ = NULL;
				gchar* _tmp25_ = NULL;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_ = NULL;
				gchar* _tmp30_ = NULL;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp24_ = name;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp25_ = g_strdup (_tmp24_);
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp23_ = _tmp25_;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp26_ = _tmp23_;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				if (_tmp26_ == NULL) {
#line 1165 "jstools.c"
					gchar* _tmp27_ = NULL;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
					_tmp27_ = g_strdup ("null");
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
					_g_free0 (_tmp23_);
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
					_tmp23_ = _tmp27_;
#line 1173 "jstools.c"
				}
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp28_ = _tmp23_;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp29_ = message;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp30_ = g_strdup_printf ("%s: %s. Enable JS debugging for more details.", _tmp28_, _tmp29_);
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				result = _tmp30_;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_g_free0 (_tmp23_);
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_g_free0 (file);
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_g_free0 (name);
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_g_free0 (message);
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				return result;
#line 1193 "jstools.c"
			}
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp32_ = file;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp33_ = g_strdup (_tmp32_);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp31_ = _tmp33_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp34_ = _tmp31_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			if (_tmp34_ == NULL) {
#line 1205 "jstools.c"
				gchar* _tmp35_ = NULL;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp35_ = g_strdup ("(null)");
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_g_free0 (_tmp31_);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp31_ = _tmp35_;
#line 1213 "jstools.c"
			}
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp37_ = name;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp38_ = g_strdup (_tmp37_);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp36_ = _tmp38_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp39_ = _tmp36_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			if (_tmp39_ == NULL) {
#line 1225 "jstools.c"
				gchar* _tmp40_ = NULL;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp40_ = g_strdup ("null");
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_g_free0 (_tmp36_);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
				_tmp36_ = _tmp40_;
#line 1233 "jstools.c"
			}
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp41_ = _tmp31_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp42_ = line;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp43_ = _tmp36_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp44_ = message;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_tmp45_ = g_strdup_printf ("%s:%d: %s: %s", _tmp41_, _tmp42_, _tmp43_, _tmp44_);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			result = _tmp45_;
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_g_free0 (_tmp36_);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_g_free0 (_tmp31_);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_g_free0 (file);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_g_free0 (name);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			_g_free0 (message);
#line 204 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
			return result;
#line 1259 "jstools.c"
		}
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_g_free0 (message);
#line 1263 "jstools.c"
	}
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp46_ = ctx;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp47_ = value;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp48_ = nuvola_js_tools_value_to_string (_tmp46_, _tmp47_);
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = _tmp48_;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 1275 "jstools.c"
}


void* nuvola_js_tools_get_gobject_property_named (void* ctx, GObject* o, const gchar* name) {
	void* result = NULL;
	GObjectClass* klass = NULL;
	GObject* _tmp0_ = NULL;
	GType _tmp1_ = 0UL;
	GTypeClass* _tmp2_ = NULL;
	GParamSpec* p = NULL;
	GObjectClass* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GParamSpec* _tmp5_ = NULL;
	GParamSpec* _tmp6_ = NULL;
	void* _tmp9_ = NULL;
	GObject* _tmp10_ = NULL;
	GParamSpec* _tmp11_ = NULL;
	void* _tmp12_ = NULL;
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, NULL);
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (o != NULL, NULL);
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = o;
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = G_TYPE_FROM_INSTANCE (_tmp0_);
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = g_type_class_ref (_tmp1_);
#line 212 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	klass = (GObjectClass*) _tmp2_;
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp3_ = klass;
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp4_ = name;
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp5_ = g_object_class_find_property (_tmp3_, _tmp4_);
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	p = _tmp5_;
#line 214 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp6_ = p;
#line 214 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp6_ == NULL) {
#line 1320 "jstools.c"
		void* _tmp7_ = NULL;
		void* _tmp8_ = NULL;
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp7_ = ctx;
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp8_ = JSValueMakeUndefined (_tmp7_);
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp8_;
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_g_type_class_unref0 (klass);
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 1333 "jstools.c"
	}
#line 216 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp9_ = ctx;
#line 216 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp10_ = o;
#line 216 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp11_ = p;
#line 216 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp12_ = nuvola_js_tools_get_gobject_property (_tmp9_, _tmp10_, _tmp11_);
#line 216 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = _tmp12_;
#line 216 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_g_type_class_unref0 (klass);
#line 216 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 1349 "jstools.c"
}


void* nuvola_js_tools_get_gobject_property (void* ctx, GObject* o, GParamSpec* p) {
	void* result = NULL;
	GType type = 0UL;
	GParamSpec* _tmp0_ = NULL;
	GType _tmp1_ = 0UL;
	GType _tmp2_ = 0UL;
	GType _tmp12_ = 0UL;
	GType _tmp19_ = 0UL;
	GType _tmp26_ = 0UL;
	GType _tmp33_ = 0UL;
	void* _tmp40_ = NULL;
	void* _tmp41_ = NULL;
#line 219 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (ctx != NULL, NULL);
#line 219 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (o != NULL, NULL);
#line 219 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	g_return_val_if_fail (p != NULL, NULL);
#line 221 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp0_ = p;
#line 221 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp1_ = _tmp0_->value_type;
#line 221 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	type = _tmp1_;
#line 222 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp2_ = type;
#line 222 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp2_ == G_TYPE_STRING) {
#line 1381 "jstools.c"
		gchar* str_val = NULL;
		GObject* _tmp3_ = NULL;
		GParamSpec* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		void* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		void* _tmp8_ = NULL;
		void* _tmp9_ = NULL;
		void* _tmp10_ = NULL;
		void* _tmp11_ = NULL;
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp3_ = o;
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp4_ = p;
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp5_ = _tmp4_->name;
#line 225 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		g_object_get (_tmp3_, _tmp5_, &str_val, NULL);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp6_ = ctx;
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp7_ = str_val;
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp8_ = JSStringCreateWithUTF8CString (_tmp7_);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp9_ = _tmp8_;
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp10_ = JSValueMakeString (_tmp6_, _tmp9_);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp11_ = _tmp10_;
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_JSStringRelease0 (_tmp9_);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp11_;
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_g_free0 (str_val);
#line 226 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 1420 "jstools.c"
	}
#line 229 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp12_ = type;
#line 229 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp12_ == G_TYPE_INT) {
#line 1426 "jstools.c"
		gint int_val = 0;
		GObject* _tmp13_ = NULL;
		GParamSpec* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		void* _tmp16_ = NULL;
		gint _tmp17_ = 0;
		void* _tmp18_ = NULL;
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp13_ = o;
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp14_ = p;
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp15_ = _tmp14_->name;
#line 232 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		g_object_get (_tmp13_, _tmp15_, &int_val, NULL);
#line 233 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp16_ = ctx;
#line 233 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp17_ = int_val;
#line 233 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp18_ = JSValueMakeNumber (_tmp16_, (gdouble) _tmp17_);
#line 233 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp18_;
#line 233 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 1452 "jstools.c"
	}
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp19_ = type;
#line 236 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp19_ == G_TYPE_FLOAT) {
#line 1458 "jstools.c"
		gfloat float_val = 0.0F;
		GObject* _tmp20_ = NULL;
		GParamSpec* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
		void* _tmp23_ = NULL;
		gfloat _tmp24_ = 0.0F;
		void* _tmp25_ = NULL;
#line 239 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp20_ = o;
#line 239 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp21_ = p;
#line 239 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp22_ = _tmp21_->name;
#line 239 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		g_object_get (_tmp20_, _tmp22_, &float_val, NULL);
#line 240 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp23_ = ctx;
#line 240 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp24_ = float_val;
#line 240 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp25_ = JSValueMakeNumber (_tmp23_, (gdouble) _tmp24_);
#line 240 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp25_;
#line 240 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 1484 "jstools.c"
	}
#line 243 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp26_ = type;
#line 243 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp26_ == G_TYPE_DOUBLE) {
#line 1490 "jstools.c"
		gdouble double_val = 0.0;
		GObject* _tmp27_ = NULL;
		GParamSpec* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		void* _tmp30_ = NULL;
		gdouble _tmp31_ = 0.0;
		void* _tmp32_ = NULL;
#line 246 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp27_ = o;
#line 246 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp28_ = p;
#line 246 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp29_ = _tmp28_->name;
#line 246 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		g_object_get (_tmp27_, _tmp29_, &double_val, NULL);
#line 247 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp30_ = ctx;
#line 247 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp31_ = double_val;
#line 247 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp32_ = JSValueMakeNumber (_tmp30_, (gdouble) _tmp31_);
#line 247 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp32_;
#line 247 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 1516 "jstools.c"
	}
#line 250 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp33_ = type;
#line 250 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	if (_tmp33_ == G_TYPE_BOOLEAN) {
#line 1522 "jstools.c"
		gboolean bool_val = FALSE;
		GObject* _tmp34_ = NULL;
		GParamSpec* _tmp35_ = NULL;
		const gchar* _tmp36_ = NULL;
		void* _tmp37_ = NULL;
		gboolean _tmp38_ = FALSE;
		void* _tmp39_ = NULL;
#line 253 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp34_ = o;
#line 253 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp35_ = p;
#line 253 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp36_ = _tmp35_->name;
#line 253 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		g_object_get (_tmp34_, _tmp36_, &bool_val, NULL);
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp37_ = ctx;
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp38_ = bool_val;
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		_tmp39_ = JSValueMakeBoolean (_tmp37_, _tmp38_);
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		result = _tmp39_;
#line 254 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
		return result;
#line 1548 "jstools.c"
	}
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp40_ = ctx;
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	_tmp41_ = JSValueMakeUndefined (_tmp40_);
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	result = _tmp41_;
#line 257 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/jstools.vala"
	return result;
#line 1558 "jstools.c"
}



