/* nuvola-formatsupport.c generated by valac 0.22.1, the Vala compiler
 * generated from nuvola-formatsupport.vala, do not modify */

/*
 * Copyright 2011-2013 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <webkit/webkit.h>


#define NUVOLA_TYPE_FORMAT_SUPPORT (nuvola_format_support_get_type ())
#define NUVOLA_FORMAT_SUPPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NUVOLA_TYPE_FORMAT_SUPPORT, NuvolaFormatSupport))
#define NUVOLA_FORMAT_SUPPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NUVOLA_TYPE_FORMAT_SUPPORT, NuvolaFormatSupportClass))
#define NUVOLA_IS_FORMAT_SUPPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NUVOLA_TYPE_FORMAT_SUPPORT))
#define NUVOLA_IS_FORMAT_SUPPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NUVOLA_TYPE_FORMAT_SUPPORT))
#define NUVOLA_FORMAT_SUPPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NUVOLA_TYPE_FORMAT_SUPPORT, NuvolaFormatSupportClass))

typedef struct _NuvolaFormatSupport NuvolaFormatSupport;
typedef struct _NuvolaFormatSupportClass NuvolaFormatSupportClass;
typedef struct _NuvolaFormatSupportPrivate NuvolaFormatSupportPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NuvolaFormatSupport {
	GObject parent_instance;
	NuvolaFormatSupportPrivate * priv;
};

struct _NuvolaFormatSupportClass {
	GObjectClass parent_class;
	void (*check_all) (NuvolaFormatSupport* self);
};

struct _NuvolaFormatSupportPrivate {
	gboolean _flash_available;
	gboolean _mp3_available;
	gboolean _flash_enabled;
	gboolean _mp3_enabled;
	gboolean _block_incompatible_flash;
	gchar* mp3_uri;
	GstPlugin* gst_typefind_plugin;
};


static gpointer nuvola_format_support_parent_class = NULL;

GType nuvola_format_support_get_type (void) G_GNUC_CONST;
#define NUVOLA_FORMAT_SUPPORT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NUVOLA_TYPE_FORMAT_SUPPORT, NuvolaFormatSupportPrivate))
enum  {
	NUVOLA_FORMAT_SUPPORT_DUMMY_PROPERTY,
	NUVOLA_FORMAT_SUPPORT_FLASH_AVAILABLE,
	NUVOLA_FORMAT_SUPPORT_MP3_AVAILABLE,
	NUVOLA_FORMAT_SUPPORT_FLASH_ENABLED,
	NUVOLA_FORMAT_SUPPORT_MP3_ENABLED,
	NUVOLA_FORMAT_SUPPORT_BLOCK_INCOMPATIBLE_FLASH
};
#define NUVOLA_FORMAT_SUPPORT_MP3_SUPPORT_URL "http://nuvolaplayer.fenryxo.cz/help/issues/html5_audio.html"
#define NUVOLA_FORMAT_SUPPORT_FLASH_SUPPORT_URL "http://nuvolaplayer.fenryxo.cz/help/issues/flash_plugin.html"
NuvolaFormatSupport* nuvola_format_support_new (const gchar* mp3_uri);
NuvolaFormatSupport* nuvola_format_support_construct (GType object_type, const gchar* mp3_uri);
static void nuvola_format_support_init_gstreamer (NuvolaFormatSupport* self);
void nuvola_format_support_disable_gstreamer (NuvolaFormatSupport* self);
static void nuvola_format_support_set_mp3_enabled (NuvolaFormatSupport* self, gboolean value);
gboolean nuvola_format_support_check_mp3_support (NuvolaFormatSupport* self);
static void nuvola_format_support_set_mp3_available (NuvolaFormatSupport* self, gboolean value);
static GstPipeline* nuvola_format_support_create_gst_pipeline (NuvolaFormatSupport* self, const gchar* mp3_uri, gchar** _error_);
gboolean nuvola_format_support_check_flash_support (NuvolaFormatSupport* self);
gboolean nuvola_format_support_get_block_incompatible_flash (NuvolaFormatSupport* self);
gboolean nuvola_format_support_get_flash_available (NuvolaFormatSupport* self);
static void nuvola_format_support_set_flash_available (NuvolaFormatSupport* self, gboolean value);
gboolean nuvola_format_support_get_mp3_available (NuvolaFormatSupport* self);
gboolean nuvola_format_support_get_flash_enabled (NuvolaFormatSupport* self);
void nuvola_format_support_set_flash_enabled (NuvolaFormatSupport* self, gboolean value);
gboolean nuvola_format_support_get_mp3_enabled (NuvolaFormatSupport* self);
void nuvola_format_support_set_block_incompatible_flash (NuvolaFormatSupport* self, gboolean value);
static void nuvola_format_support_real_check_all (NuvolaFormatSupport* self);
static void nuvola_format_support_finalize (GObject* obj);
static void _vala_nuvola_format_support_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_nuvola_format_support_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


NuvolaFormatSupport* nuvola_format_support_construct (GType object_type, const gchar* mp3_uri) {
	NuvolaFormatSupport * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self = (NuvolaFormatSupport*) g_object_new (object_type, NULL);
#line 43 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	nuvola_format_support_init_gstreamer (self);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = mp3_uri;
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_free0 (self->priv->mp3_uri);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->mp3_uri = _tmp1_;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_object_unref0 (self->priv->gst_typefind_plugin);
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->gst_typefind_plugin = NULL;
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return self;
#line 133 "nuvola-formatsupport.c"
}


NuvolaFormatSupport* nuvola_format_support_new (const gchar* mp3_uri) {
#line 41 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return nuvola_format_support_construct (NUVOLA_TYPE_FORMAT_SUPPORT, mp3_uri);
#line 140 "nuvola-formatsupport.c"
}


/**
 * Disable GStreamer support
 * 
 */
static gpointer _g_object_ref0 (gpointer self) {
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return self ? g_object_ref (self) : NULL;
#line 151 "nuvola-formatsupport.c"
}


void nuvola_format_support_disable_gstreamer (NuvolaFormatSupport* self) {
	GstRegistry* registry = NULL;
	GstRegistry* _tmp0_ = NULL;
	GstRegistry* _tmp1_ = NULL;
	GstPlugin* plugin = NULL;
	GstRegistry* _tmp2_ = NULL;
	GstPlugin* _tmp3_ = NULL;
	GstPlugin* _tmp4_ = NULL;
	gboolean _tmp13_ = FALSE;
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_if_fail (self != NULL);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = gst_registry_get ();
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 68 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	registry = _tmp1_;
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp2_ = registry;
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp3_ = gst_registry_find_plugin (_tmp2_, "typefindfunctions");
#line 73 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	plugin = _tmp3_;
#line 74 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp4_ = plugin;
#line 74 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	if (_tmp4_ != NULL) {
#line 182 "nuvola-formatsupport.c"
		GstRegistry* _tmp5_ = NULL;
		GstPlugin* _tmp6_ = NULL;
		GstPlugin* _tmp7_ = NULL;
		GstPlugin* _tmp8_ = NULL;
		GstPlugin* _tmp9_ = NULL;
		GstObject* _tmp10_ = NULL;
		GstObject* _tmp11_ = NULL;
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp5_ = registry;
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp6_ = plugin;
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		gst_registry_remove_plugin (_tmp5_, _tmp6_);
#line 77 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp7_ = plugin;
#line 77 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 77 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_object_unref0 (self->priv->gst_typefind_plugin);
#line 77 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		self->priv->gst_typefind_plugin = _tmp8_;
#line 78 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp9_ = plugin;
#line 78 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp10_ = gst_object_ref ((GstObject*) _tmp9_);
#line 78 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp11_ = _tmp10_;
#line 78 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_object_unref0 (_tmp11_);
#line 79 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_debug ("nuvola-formatsupport.vala:79: GStreamer has been disabled.");
#line 214 "nuvola-formatsupport.c"
	} else {
		GstPlugin* _tmp12_ = NULL;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp12_ = self->priv->gst_typefind_plugin;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		if (_tmp12_ == NULL) {
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			g_warning ("nuvola-formatsupport.vala:83: Failed to disable GStreamer");
#line 223 "nuvola-formatsupport.c"
		}
	}
#line 86 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	nuvola_format_support_set_mp3_enabled (self, FALSE);
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp13_ = nuvola_format_support_check_mp3_support (self);
#line 87 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	nuvola_format_support_set_mp3_available (self, _tmp13_);
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_object_unref0 (plugin);
#line 63 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_object_unref0 (registry);
#line 236 "nuvola-formatsupport.c"
}


static void nuvola_format_support_init_gstreamer (NuvolaFormatSupport* self) {
	gchar** a = NULL;
	gchar** _tmp0_ = NULL;
	gint a_length1 = 0;
	gint _a_size_ = 0;
	gchar** b = NULL;
	gint b_length1 = 0;
	gint _b_size_ = 0;
	GError * _inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_if_fail (self != NULL);
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	a = _tmp0_;
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	a_length1 = 0;
#line 92 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_a_size_ = a_length1;
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	b = a;
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	b_length1 = a_length1;
#line 93 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_b_size_ = b_length1;
#line 265 "nuvola-formatsupport.c"
	{
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp2_ = gst_init_check (&b_length1, &b, &_inner_error_);
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp1_ = _tmp2_;
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		if (_inner_error_ != NULL) {
#line 277 "nuvola-formatsupport.c"
			goto __catch39_g_error;
		}
#line 96 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		if (!_tmp1_) {
#line 282 "nuvola-formatsupport.c"
		}
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp3_ = gst_version_string ();
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp4_ = _tmp3_;
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_debug ("nuvola-formatsupport.vala:97: Unable to init %s, maybe already initial" \
"ized", _tmp4_);
#line 97 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (_tmp4_);
#line 292 "nuvola-formatsupport.c"
	}
	goto __finally39;
	__catch39_g_error:
	{
		GError* e = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		e = _inner_error_;
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_inner_error_ = NULL;
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp5_ = gst_version_string ();
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp6_ = _tmp5_;
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp7_ = e;
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp8_ = _tmp7_->message;
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_warning ("nuvola-formatsupport.vala:101: Unable to init %s: %s", _tmp6_, _tmp8_);
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (_tmp6_);
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_error_free0 (e);
#line 320 "nuvola-formatsupport.c"
	}
	__finally39:
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	if (_inner_error_ != NULL) {
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		a = (_vala_array_free (a, a_length1, (GDestroyNotify) g_free), NULL);
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_clear_error (&_inner_error_);
#line 94 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		return;
#line 333 "nuvola-formatsupport.c"
	}
#line 90 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	a = (_vala_array_free (a, a_length1, (GDestroyNotify) g_free), NULL);
#line 337 "nuvola-formatsupport.c"
}


static GstPipeline* nuvola_format_support_create_gst_pipeline (NuvolaFormatSupport* self, const gchar* mp3_uri, gchar** _error_) {
	gchar* _vala_error = NULL;
	GstPipeline* result = NULL;
	GError * _inner_error_ = NULL;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_val_if_fail (mp3_uri != NULL, NULL);
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_free0 (_vala_error);
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_vala_error = NULL;
#line 353 "nuvola-formatsupport.c"
	{
		gchar* launch_string = NULL;
		gchar* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		GstElement* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		GstElement* _tmp11_ = NULL;
		GstPipeline* pipeline = NULL;
		GstPipeline* _tmp12_ = NULL;
		GstPipeline* _tmp13_ = NULL;
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp0_ = g_strdup ("playbin");
#line 114 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		launch_string = _tmp0_;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp1_ = launch_string;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp2_ = mp3_uri;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp3_ = g_strconcat (" uri=", _tmp2_, NULL);
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp4_ = _tmp3_;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (launch_string);
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		launch_string = _tmp5_;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (_tmp4_);
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp6_ = gst_version_string ();
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp7_ = _tmp6_;
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp8_ = launch_string;
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_debug ("nuvola-formatsupport.vala:117: %s launch %s", _tmp7_, _tmp8_);
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (_tmp7_);
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp10_ = launch_string;
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp11_ = gst_parse_launch_full (_tmp10_, NULL, GST_PARSE_FLAG_NONE, &_inner_error_);
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_object_ref_sink (_tmp11_);
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp9_ = _tmp11_;
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		if (_inner_error_ != NULL) {
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (launch_string);
#line 413 "nuvola-formatsupport.c"
			goto __catch40_g_error;
		}
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_object_ref_sink (_tmp9_);
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, gst_pipeline_get_type ()) ? ((GstPipeline*) _tmp9_) : NULL;
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		if (_tmp12_ == NULL) {
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_object_unref0 (_tmp9_);
#line 424 "nuvola-formatsupport.c"
		}
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		pipeline = _tmp12_;
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp13_ = pipeline;
#line 119 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		if (_tmp13_ == NULL) {
#line 432 "nuvola-formatsupport.c"
			gchar* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_ = NULL;
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp14_ = gst_version_string ();
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp15_ = _tmp14_;
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp16_ = g_strdup_printf ("Unable to create %s pipeline", _tmp15_);
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (_vala_error);
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_vala_error = _tmp16_;
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (_tmp15_);
#line 448 "nuvola-formatsupport.c"
		}
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		result = pipeline;
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (launch_string);
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		if (_error_) {
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			*_error_ = _vala_error;
#line 458 "nuvola-formatsupport.c"
		} else {
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (_vala_error);
#line 462 "nuvola-formatsupport.c"
		}
#line 122 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		return result;
#line 466 "nuvola-formatsupport.c"
	}
	goto __finally40;
	__catch40_g_error:
	{
		GError* e = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		GError* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		e = _inner_error_;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_inner_error_ = NULL;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp17_ = gst_version_string ();
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp18_ = _tmp17_;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp19_ = e;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp20_ = _tmp19_->message;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp21_ = g_strdup_printf ("Failed to create a %s pipeline: %s", _tmp18_, _tmp20_);
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (_vala_error);
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_vala_error = _tmp21_;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (_tmp18_);
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		result = NULL;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_error_free0 (e);
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		if (_error_) {
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			*_error_ = _vala_error;
#line 505 "nuvola-formatsupport.c"
		} else {
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (_vala_error);
#line 509 "nuvola-formatsupport.c"
		}
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		return result;
#line 513 "nuvola-formatsupport.c"
	}
	__finally40:
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_clear_error (&_inner_error_);
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return NULL;
#line 522 "nuvola-formatsupport.c"
}


/**
 * Check whether it's possible to play a MP3 file
 * 
 * @param mp3_file		a MP3 file to test
 * @return true on success, false on failure
 */
gboolean nuvola_format_support_check_mp3_support (NuvolaFormatSupport* self) {
	gboolean result = FALSE;
	gchar* error_msg = NULL;
	const gchar* _tmp0_ = NULL;
	GstPipeline* pipeline = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GstPipeline* _tmp3_ = NULL;
	GstPipeline* _tmp4_ = NULL;
	GstPipeline* _tmp6_ = NULL;
	GstStateChangeReturn _tmp7_ = 0;
#line 137 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 139 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_debug ("nuvola-formatsupport.vala:139: Built with Gstreamer %d.%d.%d", GST_VERSION_MAJOR, GST_VERSION_MINOR, GST_VERSION_MICRO);
#line 140 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_setenv ("GST_DEBUG", "*:2", FALSE);
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = self->priv->mp3_uri;
#line 142 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	if (_tmp0_ == NULL) {
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		result = FALSE;
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (error_msg);
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		return result;
#line 559 "nuvola-formatsupport.c"
	}
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp1_ = self->priv->mp3_uri;
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp3_ = nuvola_format_support_create_gst_pipeline (self, _tmp1_, &_tmp2_);
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_free0 (error_msg);
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	error_msg = _tmp2_;
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	pipeline = _tmp3_;
#line 145 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp4_ = pipeline;
#line 145 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	if (_tmp4_ == NULL) {
#line 575 "nuvola-formatsupport.c"
		const gchar* _tmp5_ = NULL;
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp5_ = error_msg;
#line 147 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_warning ("nuvola-formatsupport.vala:147: %s", _tmp5_);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		result = FALSE;
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_object_unref0 (pipeline);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (error_msg);
#line 148 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		return result;
#line 589 "nuvola-formatsupport.c"
	}
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp6_ = pipeline;
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp7_ = gst_element_set_state ((GstElement*) _tmp6_, GST_STATE_PAUSED);
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	switch (_tmp7_) {
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case GST_STATE_CHANGE_SUCCESS:
#line 599 "nuvola-formatsupport.c"
		{
			GstPipeline* _tmp8_ = NULL;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp8_ = pipeline;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			gst_element_set_state ((GstElement*) _tmp8_, GST_STATE_NULL);
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			result = TRUE;
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_object_unref0 (pipeline);
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (error_msg);
#line 157 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			return result;
#line 614 "nuvola-formatsupport.c"
		}
#line 153 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case GST_STATE_CHANGE_ASYNC:
#line 618 "nuvola-formatsupport.c"
		{
			GstStateChangeReturn state_change = 0;
			GstPipeline* _tmp9_ = NULL;
			GstStateChangeReturn _tmp10_ = 0;
			GstPipeline* _tmp11_ = NULL;
			GstStateChangeReturn _tmp12_ = 0;
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_ = NULL;
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp9_ = pipeline;
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp10_ = gst_element_get_state ((GstElement*) _tmp9_, NULL, NULL, GST_CLOCK_TIME_NONE);
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			state_change = _tmp10_;
#line 160 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp11_ = pipeline;
#line 160 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			gst_element_set_state ((GstElement*) _tmp11_, GST_STATE_NULL);
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp12_ = state_change;
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			if (_tmp12_ == GST_STATE_CHANGE_SUCCESS) {
#line 162 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				result = TRUE;
#line 162 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_g_object_unref0 (pipeline);
#line 162 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_g_free0 (error_msg);
#line 162 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				return result;
#line 649 "nuvola-formatsupport.c"
			}
#line 164 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp13_ = gst_version_string ();
#line 164 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp14_ = _tmp13_;
#line 164 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			g_warning ("nuvola-formatsupport.vala:164: Unable to change %s pipeline status (as" \
"ync)", _tmp14_);
#line 164 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (_tmp14_);
#line 165 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			result = FALSE;
#line 165 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_object_unref0 (pipeline);
#line 165 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (error_msg);
#line 165 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			return result;
#line 667 "nuvola-formatsupport.c"
		}
		default:
		{
			GstPipeline* _tmp15_ = NULL;
			gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
#line 167 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp15_ = pipeline;
#line 167 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			gst_element_set_state ((GstElement*) _tmp15_, GST_STATE_NULL);
#line 168 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp16_ = gst_version_string ();
#line 168 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp17_ = _tmp16_;
#line 168 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			g_warning ("nuvola-formatsupport.vala:168: Unable to change %s pipeline status (sy" \
"nc)", _tmp17_);
#line 168 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (_tmp17_);
#line 169 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			result = FALSE;
#line 169 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_object_unref0 (pipeline);
#line 169 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_g_free0 (error_msg);
#line 169 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			return result;
#line 694 "nuvola-formatsupport.c"
		}
	}
#line 137 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_object_unref0 (pipeline);
#line 137 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_free0 (error_msg);
#line 701 "nuvola-formatsupport.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 1237 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1237 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1238 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1238 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1238 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1238 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	return result;
#line 721 "nuvola-formatsupport.c"
}


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
	if (self) {
#line 729 "nuvola-formatsupport.c"
		gchar* _tmp0_ = NULL;
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		result = _tmp0_;
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		return result;
#line 737 "nuvola-formatsupport.c"
	} else {
		gchar* _tmp1_ = NULL;
#line 40 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		result = _tmp1_;
#line 40 "/builddir/build/BUILD/nuvolaplayer-2.5/external/vala-0.22/glib-2.0.vapi"
		return result;
#line 746 "nuvola-formatsupport.c"
	}
}


gboolean nuvola_format_support_check_flash_support (NuvolaFormatSupport* self) {
	gboolean result = FALSE;
#line 175 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	static const char PLUGIN_DIR_KEY[] = "MOZ_PLUGIN_PATH";
#line 176 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	static const char NUVOLA_FLASH_DIR[] = "/opt/nuvolaplayer/flash/wrapped";
#line 177 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	static const char NUVOLA_FLASH_LIBNAME[] = "/npwrapper.libflashplayer.so";
#line 178 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	static const char FLASH_PLUGIN_NAME[] = "Shockwave Flash";
#line 761 "nuvola-formatsupport.c"
	gchar* plugin_dirs = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp9_ = NULL;
	gboolean flash_available = FALSE;
	WebKitWebPluginDatabase* db = NULL;
	WebKitWebPluginDatabase* _tmp10_ = NULL;
	WebKitWebPluginDatabase* _tmp11_ = NULL;
	GSList* plugins = NULL;
	WebKitWebPluginDatabase* _tmp12_ = NULL;
	GSList* _tmp13_ = NULL;
	GSList* _tmp14_ = NULL;
#line 173 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = g_getenv (PLUGIN_DIR_KEY);
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 180 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	plugin_dirs = _tmp1_;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp3_ = plugin_dirs;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	if (_tmp3_ == NULL) {
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp2_ = TRUE;
#line 791 "nuvola-formatsupport.c"
	} else {
		const gchar* _tmp4_ = NULL;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp4_ = plugin_dirs;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 798 "nuvola-formatsupport.c"
	}
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp5_ = _tmp2_;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	if (_tmp5_) {
#line 804 "nuvola-formatsupport.c"
		gchar* _tmp6_ = NULL;
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp6_ = g_strdup (NUVOLA_FLASH_DIR);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (plugin_dirs);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		plugin_dirs = _tmp6_;
#line 812 "nuvola-formatsupport.c"
	} else {
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp7_ = plugin_dirs;
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp8_ = g_strdup_printf ("%s:%s", NUVOLA_FLASH_DIR, _tmp7_);
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_g_free0 (plugin_dirs);
#line 185 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		plugin_dirs = _tmp8_;
#line 824 "nuvola-formatsupport.c"
	}
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp9_ = plugin_dirs;
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_setenv (PLUGIN_DIR_KEY, _tmp9_, TRUE);
#line 190 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	flash_available = FALSE;
#line 191 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp10_ = webkit_get_web_plugin_database ();
#line 191 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 191 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	db = _tmp11_;
#line 192 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp12_ = db;
#line 192 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp13_ = webkit_web_plugin_database_get_plugins (_tmp12_);
#line 192 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	plugins = _tmp13_;
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp14_ = plugins;
#line 846 "nuvola-formatsupport.c"
	{
		GSList* plugin_collection = NULL;
		GSList* plugin_it = NULL;
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		plugin_collection = _tmp14_;
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		for (plugin_it = plugin_collection; plugin_it != NULL; plugin_it = plugin_it->next) {
#line 854 "nuvola-formatsupport.c"
			WebKitWebPlugin* _tmp15_ = NULL;
			WebKitWebPlugin* plugin = NULL;
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			_tmp15_ = _g_object_ref0 ((WebKitWebPlugin*) plugin_it->data);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
			plugin = _tmp15_;
#line 861 "nuvola-formatsupport.c"
			{
				gchar* path = NULL;
				WebKitWebPlugin* _tmp16_ = NULL;
				const gchar* _tmp17_ = NULL;
				gchar* _tmp18_ = NULL;
				gchar* name = NULL;
				WebKitWebPlugin* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				gboolean _tmp22_ = FALSE;
				const gchar* _tmp31_ = NULL;
				WebKitWebPlugin* _tmp32_ = NULL;
				gboolean _tmp33_ = FALSE;
				gboolean _tmp34_ = FALSE;
				gchar* _tmp35_ = NULL;
				gchar* _tmp36_ = NULL;
				const gchar* _tmp37_ = NULL;
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp16_ = plugin;
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp17_ = webkit_web_plugin_get_path (_tmp16_);
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp18_ = g_strdup (_tmp17_);
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				path = _tmp18_;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp19_ = plugin;
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp20_ = webkit_web_plugin_get_name (_tmp19_);
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp21_ = g_strdup (_tmp20_);
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				name = _tmp21_;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp22_ = self->priv->_block_incompatible_flash;
#line 196 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				if (_tmp22_) {
#line 899 "nuvola-formatsupport.c"
					const gchar* _tmp23_ = NULL;
					gboolean _tmp24_ = FALSE;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
					_tmp23_ = path;
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
					_tmp24_ = g_str_has_suffix (_tmp23_, NUVOLA_FLASH_LIBNAME);
#line 197 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
					if (_tmp24_) {
#line 908 "nuvola-formatsupport.c"
						WebKitWebPlugin* _tmp25_ = NULL;
#line 198 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						_tmp25_ = plugin;
#line 198 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						webkit_web_plugin_set_enabled (_tmp25_, TRUE);
#line 199 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						flash_available = TRUE;
#line 916 "nuvola-formatsupport.c"
					} else {
						WebKitWebPlugin* _tmp26_ = NULL;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						_tmp26_ = plugin;
#line 202 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						webkit_web_plugin_set_enabled (_tmp26_, FALSE);
#line 923 "nuvola-formatsupport.c"
					}
				} else {
					const gchar* _tmp27_ = NULL;
					gboolean _tmp28_ = FALSE;
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
					_tmp27_ = name;
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
					_tmp28_ = string_contains (_tmp27_, FLASH_PLUGIN_NAME);
#line 205 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
					if (_tmp28_) {
#line 934 "nuvola-formatsupport.c"
						WebKitWebPlugin* _tmp29_ = NULL;
#line 206 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						flash_available = TRUE;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						_tmp29_ = plugin;
#line 207 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						webkit_web_plugin_set_enabled (_tmp29_, TRUE);
#line 942 "nuvola-formatsupport.c"
					} else {
						WebKitWebPlugin* _tmp30_ = NULL;
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						_tmp30_ = plugin;
#line 210 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
						webkit_web_plugin_set_enabled (_tmp30_, FALSE);
#line 949 "nuvola-formatsupport.c"
					}
				}
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp31_ = name;
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp32_ = plugin;
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp33_ = webkit_web_plugin_get_enabled (_tmp32_);
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp34_ = _tmp33_;
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp35_ = bool_to_string (_tmp34_);
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp36_ = _tmp35_;
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_tmp37_ = path;
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				g_debug ("nuvola-formatsupport.vala:213: WebPlugin: %s (%s): %s", _tmp31_, _tmp36_, _tmp37_);
#line 213 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_g_free0 (_tmp36_);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_g_free0 (name);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_g_free0 (path);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
				_g_object_unref0 (plugin);
#line 976 "nuvola-formatsupport.c"
			}
		}
	}
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	result = flash_available;
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_object_unref0 (db);
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_free0 (plugin_dirs);
#line 215 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return result;
#line 988 "nuvola-formatsupport.c"
}


gboolean nuvola_format_support_get_flash_available (NuvolaFormatSupport* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = self->priv->_flash_available;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return result;
#line 1003 "nuvola-formatsupport.c"
}


static void nuvola_format_support_set_flash_available (NuvolaFormatSupport* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = value;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_flash_available = _tmp0_;
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_notify ((GObject *) self, "flash-available");
#line 1017 "nuvola-formatsupport.c"
}


gboolean nuvola_format_support_get_mp3_available (NuvolaFormatSupport* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = self->priv->_mp3_available;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return result;
#line 1032 "nuvola-formatsupport.c"
}


static void nuvola_format_support_set_mp3_available (NuvolaFormatSupport* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = value;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_mp3_available = _tmp0_;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_notify ((GObject *) self, "mp3-available");
#line 1046 "nuvola-formatsupport.c"
}


gboolean nuvola_format_support_get_flash_enabled (NuvolaFormatSupport* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = self->priv->_flash_enabled;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return result;
#line 1061 "nuvola-formatsupport.c"
}


void nuvola_format_support_set_flash_enabled (NuvolaFormatSupport* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = value;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_flash_enabled = _tmp0_;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_notify ((GObject *) self, "flash-enabled");
#line 1075 "nuvola-formatsupport.c"
}


gboolean nuvola_format_support_get_mp3_enabled (NuvolaFormatSupport* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = self->priv->_mp3_enabled;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return result;
#line 1090 "nuvola-formatsupport.c"
}


static void nuvola_format_support_set_mp3_enabled (NuvolaFormatSupport* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = value;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_mp3_enabled = _tmp0_;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_notify ((GObject *) self, "mp3-enabled");
#line 1104 "nuvola-formatsupport.c"
}


gboolean nuvola_format_support_get_block_incompatible_flash (NuvolaFormatSupport* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = self->priv->_block_incompatible_flash;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	return result;
#line 1119 "nuvola-formatsupport.c"
}


void nuvola_format_support_set_block_incompatible_flash (NuvolaFormatSupport* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_return_if_fail (self != NULL);
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = value;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_block_incompatible_flash = _tmp0_;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_notify ((GObject *) self, "block-incompatible-flash");
#line 1133 "nuvola-formatsupport.c"
}


static void nuvola_format_support_real_check_all (NuvolaFormatSupport* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = nuvola_format_support_check_flash_support (self);
#line 55 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	nuvola_format_support_set_flash_available (self, _tmp0_);
#line 56 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp1_ = nuvola_format_support_check_mp3_support (self);
#line 56 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	nuvola_format_support_set_mp3_available (self, _tmp1_);
#line 1148 "nuvola-formatsupport.c"
}


static void nuvola_format_support_class_init (NuvolaFormatSupportClass * klass) {
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	nuvola_format_support_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_type_class_add_private (klass, sizeof (NuvolaFormatSupportPrivate));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	NUVOLA_FORMAT_SUPPORT_CLASS (klass)->check_all = nuvola_format_support_real_check_all;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_nuvola_format_support_get_property;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_nuvola_format_support_set_property;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	G_OBJECT_CLASS (klass)->finalize = nuvola_format_support_finalize;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_FORMAT_SUPPORT_FLASH_AVAILABLE, g_param_spec_boolean ("flash-available", "flash-available", "flash-available", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_FORMAT_SUPPORT_MP3_AVAILABLE, g_param_spec_boolean ("mp3-available", "mp3-available", "mp3-available", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_FORMAT_SUPPORT_FLASH_ENABLED, g_param_spec_boolean ("flash-enabled", "flash-enabled", "flash-enabled", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_FORMAT_SUPPORT_MP3_ENABLED, g_param_spec_boolean ("mp3-enabled", "mp3-enabled", "mp3-enabled", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NUVOLA_FORMAT_SUPPORT_BLOCK_INCOMPATIBLE_FLASH, g_param_spec_boolean ("block-incompatible-flash", "block-incompatible-flash", "block-incompatible-flash", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	g_signal_new ("check_all", NUVOLA_TYPE_FORMAT_SUPPORT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (NuvolaFormatSupportClass, check_all), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1177 "nuvola-formatsupport.c"
}


static void nuvola_format_support_instance_init (NuvolaFormatSupport * self) {
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv = NUVOLA_FORMAT_SUPPORT_GET_PRIVATE (self);
#line 33 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_flash_available = FALSE;
#line 34 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_mp3_available = FALSE;
#line 35 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_flash_enabled = TRUE;
#line 36 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_mp3_enabled = TRUE;
#line 37 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self->priv->_block_incompatible_flash = TRUE;
#line 1194 "nuvola-formatsupport.c"
}


static void nuvola_format_support_finalize (GObject* obj) {
	NuvolaFormatSupport * self;
	GstPlugin* _tmp0_ = NULL;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NUVOLA_TYPE_FORMAT_SUPPORT, NuvolaFormatSupport);
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_tmp0_ = self->priv->gst_typefind_plugin;
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	if (_tmp0_ != NULL) {
#line 1207 "nuvola-formatsupport.c"
		GstPlugin* _tmp1_ = NULL;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		_tmp1_ = self->priv->gst_typefind_plugin;
#line 51 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		gst_object_unref ((GstObject*) _tmp1_);
#line 1213 "nuvola-formatsupport.c"
	}
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_free0 (self->priv->mp3_uri);
#line 39 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	_g_object_unref0 (self->priv->gst_typefind_plugin);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	G_OBJECT_CLASS (nuvola_format_support_parent_class)->finalize (obj);
#line 1221 "nuvola-formatsupport.c"
}


GType nuvola_format_support_get_type (void) {
	static volatile gsize nuvola_format_support_type_id__volatile = 0;
	if (g_once_init_enter (&nuvola_format_support_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NuvolaFormatSupportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nuvola_format_support_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NuvolaFormatSupport), 0, (GInstanceInitFunc) nuvola_format_support_instance_init, NULL };
		GType nuvola_format_support_type_id;
		nuvola_format_support_type_id = g_type_register_static (G_TYPE_OBJECT, "NuvolaFormatSupport", &g_define_type_info, 0);
		g_once_init_leave (&nuvola_format_support_type_id__volatile, nuvola_format_support_type_id);
	}
	return nuvola_format_support_type_id__volatile;
}


static void _vala_nuvola_format_support_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NuvolaFormatSupport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_FORMAT_SUPPORT, NuvolaFormatSupport);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_FLASH_AVAILABLE:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_value_set_boolean (value, nuvola_format_support_get_flash_available (self));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_MP3_AVAILABLE:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_value_set_boolean (value, nuvola_format_support_get_mp3_available (self));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_FLASH_ENABLED:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_value_set_boolean (value, nuvola_format_support_get_flash_enabled (self));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_MP3_ENABLED:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_value_set_boolean (value, nuvola_format_support_get_mp3_enabled (self));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_BLOCK_INCOMPATIBLE_FLASH:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		g_value_set_boolean (value, nuvola_format_support_get_block_incompatible_flash (self));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 1272 "nuvola-formatsupport.c"
		default:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 1278 "nuvola-formatsupport.c"
	}
}


static void _vala_nuvola_format_support_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NuvolaFormatSupport * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NUVOLA_TYPE_FORMAT_SUPPORT, NuvolaFormatSupport);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_FLASH_AVAILABLE:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		nuvola_format_support_set_flash_available (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_MP3_AVAILABLE:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		nuvola_format_support_set_mp3_available (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_FLASH_ENABLED:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		nuvola_format_support_set_flash_enabled (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_MP3_ENABLED:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		nuvola_format_support_set_mp3_enabled (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		case NUVOLA_FORMAT_SUPPORT_BLOCK_INCOMPATIBLE_FLASH:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		nuvola_format_support_set_block_incompatible_flash (self, g_value_get_boolean (value));
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 1318 "nuvola-formatsupport.c"
		default:
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/nuvola-formatsupport.vala"
		break;
#line 1324 "nuvola-formatsupport.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/extensionsmanager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1332 "nuvola-formatsupport.c"
		int i;
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/extensionsmanager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/extensionsmanager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/extensionsmanager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1340 "nuvola-formatsupport.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/extensionsmanager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 38 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvola/core/extensionsmanager.vala"
	g_free (array);
#line 1352 "nuvola-formatsupport.c"
}



