/* nuvolaplayer-client.c generated by valac 0.22.1, the Vala compiler
 * generated from nuvolaplayer-client.vala, do not modify */

/*
 * Copyright 2012 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>


#define TYPE_MPRIS_PLAYER (mpris_player_get_type ())
#define MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_PLAYER, MPRISPlayer))
#define IS_MPRIS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_PLAYER))
#define MPRIS_PLAYER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MPRIS_PLAYER, MPRISPlayerIface))

typedef struct _MPRISPlayer MPRISPlayer;
typedef struct _MPRISPlayerIface MPRISPlayerIface;

#define TYPE_MPRIS_PLAYER_PROXY (mpris_player_proxy_get_type ())

#define TYPE_MPRIS_APPLICATION (mpris_application_get_type ())
#define MPRIS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MPRIS_APPLICATION, MPRISApplication))
#define IS_MPRIS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MPRIS_APPLICATION))
#define MPRIS_APPLICATION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MPRIS_APPLICATION, MPRISApplicationIface))

typedef struct _MPRISApplication MPRISApplication;
typedef struct _MPRISApplicationIface MPRISApplicationIface;

#define TYPE_MPRIS_APPLICATION_PROXY (mpris_application_proxy_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef GDBusProxy MPRISApplicationProxy;
typedef GDBusProxyClass MPRISApplicationProxyClass;
typedef GDBusProxy MPRISPlayerProxy;
typedef GDBusProxyClass MPRISPlayerProxyClass;

struct _MPRISPlayerIface {
	GTypeInterface parent_iface;
	void (*next) (MPRISPlayer* self, GError** error);
	void (*previous) (MPRISPlayer* self, GError** error);
	void (*pause) (MPRISPlayer* self, GError** error);
	void (*play_pause) (MPRISPlayer* self, GError** error);
	void (*stop) (MPRISPlayer* self, GError** error);
	void (*play) (MPRISPlayer* self, GError** error);
	gchar* (*get_playback_status) (MPRISPlayer* self);
	void (*set_playback_status) (MPRISPlayer* self, const gchar* value);
	GHashTable* (*get_metadata) (MPRISPlayer* self);
	void (*set_metadata) (MPRISPlayer* self, GHashTable* value);
};

struct _MPRISApplicationIface {
	GTypeInterface parent_iface;
	void (*raise) (MPRISApplication* self, GError** error);
	void (*quit) (MPRISApplication* self, GError** error);
};


extern gchar* prog_name;
gchar* prog_name = NULL;
extern MPRISPlayer* player;
MPRISPlayer* player = NULL;
extern MPRISApplication* app;
MPRISApplication* app = NULL;

GType mpris_player_proxy_get_type (void) G_GNUC_CONST;
guint mpris_player_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType mpris_player_get_type (void) G_GNUC_CONST;
GType mpris_application_proxy_get_type (void) G_GNUC_CONST;
guint mpris_application_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType mpris_application_get_type (void) G_GNUC_CONST;
gint _vala_main (gchar** args, int args_length1);
void usage (const gchar* command, const gchar* _error_);
gboolean call_command (const gchar* cmd, gint* exit_code);
void mpris_player_play (MPRISPlayer* self, GError** error);
void mpris_player_pause (MPRISPlayer* self, GError** error);
void mpris_player_play_pause (MPRISPlayer* self, GError** error);
void mpris_player_next (MPRISPlayer* self, GError** error);
void mpris_player_previous (MPRISPlayer* self, GError** error);
void mpris_application_raise (MPRISApplication* self, GError** error);
void mpris_application_quit (MPRISApplication* self, GError** error);
gchar* mpris_player_get_playback_status (MPRISPlayer* self);
GHashTable* mpris_player_get_metadata (MPRISPlayer* self);
static void mpris_application_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void mpris_application_proxy_raise (MPRISApplication* self, GError** error);
static void mpris_application_proxy_quit (MPRISApplication* self, GError** error);
static void mpris_application_proxy_mpris_application_interface_init (MPRISApplicationIface* iface);
static void _dbus_mpris_application_raise (MPRISApplication* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_application_quit (MPRISApplication* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void mpris_application_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* mpris_application_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean mpris_application_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _mpris_application_unregister_object (gpointer user_data);
void mpris_player_stop (MPRISPlayer* self, GError** error);
static void mpris_player_set_playback_status (MPRISPlayer* self, const gchar* value);
static void mpris_player_set_metadata (MPRISPlayer* self, GHashTable* value);
static void mpris_player_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void mpris_player_proxy_next (MPRISPlayer* self, GError** error);
static void mpris_player_proxy_previous (MPRISPlayer* self, GError** error);
static void mpris_player_proxy_pause (MPRISPlayer* self, GError** error);
static void mpris_player_proxy_play_pause (MPRISPlayer* self, GError** error);
static void mpris_player_proxy_stop (MPRISPlayer* self, GError** error);
static void mpris_player_proxy_play (MPRISPlayer* self, GError** error);
static gchar* mpris_player_dbus_proxy_get_playback_status (MPRISPlayer* self);
static void mpris_player_dbus_proxy_set_playback_status (MPRISPlayer* self, const gchar* value);
static GHashTable* mpris_player_dbus_proxy_get_metadata (MPRISPlayer* self);
static void mpris_player_dbus_proxy_set_metadata (MPRISPlayer* self, GHashTable* value);
static void mpris_player_proxy_mpris_player_interface_init (MPRISPlayerIface* iface);
static void _dbus_mpris_player_next (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_previous (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_pause (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_play_pause (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_stop (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_mpris_player_play (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_mpris_player_get_playback_status (MPRISPlayer* self);
static GVariant* _dbus_mpris_player_get_metadata (MPRISPlayer* self);
static gboolean mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_mpris_player_set_playback_status (MPRISPlayer* self, GVariant* _value);
static void _dbus_mpris_player_set_metadata (MPRISPlayer* self, GVariant* _value);
static void _mpris_player_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo * const _mpris_application_dbus_arg_info_raise_in[] = {NULL};
static const GDBusArgInfo * const _mpris_application_dbus_arg_info_raise_out[] = {NULL};
static const GDBusMethodInfo _mpris_application_dbus_method_info_raise = {-1, "Raise", (GDBusArgInfo **) (&_mpris_application_dbus_arg_info_raise_in), (GDBusArgInfo **) (&_mpris_application_dbus_arg_info_raise_out)};
static const GDBusArgInfo * const _mpris_application_dbus_arg_info_quit_in[] = {NULL};
static const GDBusArgInfo * const _mpris_application_dbus_arg_info_quit_out[] = {NULL};
static const GDBusMethodInfo _mpris_application_dbus_method_info_quit = {-1, "Quit", (GDBusArgInfo **) (&_mpris_application_dbus_arg_info_quit_in), (GDBusArgInfo **) (&_mpris_application_dbus_arg_info_quit_out)};
static const GDBusMethodInfo * const _mpris_application_dbus_method_info[] = {&_mpris_application_dbus_method_info_raise, &_mpris_application_dbus_method_info_quit, NULL};
static const GDBusSignalInfo * const _mpris_application_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _mpris_application_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _mpris_application_dbus_interface_info = {-1, "org.mpris.MediaPlayer2", (GDBusMethodInfo **) (&_mpris_application_dbus_method_info), (GDBusSignalInfo **) (&_mpris_application_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_application_dbus_property_info)};
static const GDBusInterfaceVTable _mpris_application_dbus_interface_vtable = {mpris_application_dbus_interface_method_call, mpris_application_dbus_interface_get_property, mpris_application_dbus_interface_set_property};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_next_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_next_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_next = {-1, "Next", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_next_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_next_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_previous_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_previous_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_previous = {-1, "Previous", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_previous_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_previous_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_pause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_pause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_pause = {-1, "Pause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_pause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_pause_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_play_pause_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_play_pause_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_play_pause = {-1, "PlayPause", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_play_pause_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_play_pause_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_stop_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_stop_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_stop = {-1, "Stop", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_stop_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_stop_out)};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_play_in[] = {NULL};
static const GDBusArgInfo * const _mpris_player_dbus_arg_info_play_out[] = {NULL};
static const GDBusMethodInfo _mpris_player_dbus_method_info_play = {-1, "Play", (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_play_in), (GDBusArgInfo **) (&_mpris_player_dbus_arg_info_play_out)};
static const GDBusMethodInfo * const _mpris_player_dbus_method_info[] = {&_mpris_player_dbus_method_info_next, &_mpris_player_dbus_method_info_previous, &_mpris_player_dbus_method_info_pause, &_mpris_player_dbus_method_info_play_pause, &_mpris_player_dbus_method_info_stop, &_mpris_player_dbus_method_info_play, NULL};
static const GDBusSignalInfo * const _mpris_player_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_playback_status = {-1, "PlaybackStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _mpris_player_dbus_property_info_metadata = {-1, "Metadata", "a{sv}", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo * const _mpris_player_dbus_property_info[] = {&_mpris_player_dbus_property_info_playback_status, &_mpris_player_dbus_property_info_metadata, NULL};
static const GDBusInterfaceInfo _mpris_player_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Player", (GDBusMethodInfo **) (&_mpris_player_dbus_method_info), (GDBusSignalInfo **) (&_mpris_player_dbus_signal_info), (GDBusPropertyInfo **) (&_mpris_player_dbus_property_info)};
static const GDBusInterfaceVTable _mpris_player_dbus_interface_vtable = {mpris_player_dbus_interface_method_call, mpris_player_dbus_interface_get_property, mpris_player_dbus_interface_set_property};

/**
 * Main entry point
 */
gint _vala_main (gchar** args, int args_length1) {
	gint result = 0;
#line 45 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	static const char SERVICE_NAME[] = "org.mpris.MediaPlayer2." CONFIG_APPNAME;
#line 46 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	static const char SERVICE_OBJECT[] = "/org/mpris/MediaPlayer2";
#line 200 "nuvolaplayer-client.c"
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	gint exit_code = 0;
	gchar** _tmp20_ = NULL;
	gint _tmp20__length1 = 0;
	const gchar* _tmp21_ = NULL;
	gint _tmp22_ = 0;
	gboolean _tmp23_ = FALSE;
	GError * _inner_error_ = NULL;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp0_ = args;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp0__length1 = args_length1;
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp1_ = _tmp0_[0];
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_g_free0 (prog_name);
#line 47 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	prog_name = _tmp2_;
#line 49 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	textdomain (CONFIG_APPNAME);
#line 50 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	bindtextdomain (CONFIG_APPNAME, LOCALES_DIR);
#line 230 "nuvolaplayer-client.c"
	{
		MPRISApplication* _tmp3_ = NULL;
		MPRISApplication* _tmp4_ = NULL;
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp4_ = g_initable_new (TYPE_MPRIS_APPLICATION_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", SERVICE_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", SERVICE_OBJECT, "g-interface-name", "org.mpris.MediaPlayer2", NULL);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp3_ = (MPRISApplication*) _tmp4_;
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		if (_inner_error_ != NULL) {
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 242 "nuvolaplayer-client.c"
				goto __catch0_g_io_error;
			}
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			g_clear_error (&_inner_error_);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			return 0;
#line 251 "nuvolaplayer-client.c"
		}
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_g_object_unref0 (app);
#line 53 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		app = _tmp3_;
#line 257 "nuvolaplayer-client.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		e = _inner_error_;
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_inner_error_ = NULL;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp5_ = stderr;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp6_ = _ ("Unable to connect to application interface: %s\n");
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp7_ = e;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp8_ = _tmp7_->message;
#line 57 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		fprintf (_tmp5_, _tmp6_, _tmp8_);
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		result = 1;
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_g_error_free0 (e);
#line 58 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		return result;
#line 287 "nuvolaplayer-client.c"
	}
	__finally0:
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	if (_inner_error_ != NULL) {
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		g_clear_error (&_inner_error_);
#line 52 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		return 0;
#line 298 "nuvolaplayer-client.c"
	}
	{
		MPRISPlayer* _tmp9_ = NULL;
		MPRISPlayer* _tmp10_ = NULL;
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp10_ = g_initable_new (TYPE_MPRIS_PLAYER_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", SERVICE_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", SERVICE_OBJECT, "g-interface-name", "org.mpris.MediaPlayer2.Player", NULL);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp9_ = (MPRISPlayer*) _tmp10_;
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		if (_inner_error_ != NULL) {
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			if (_inner_error_->domain == G_IO_ERROR) {
#line 311 "nuvolaplayer-client.c"
				goto __catch1_g_io_error;
			}
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			g_clear_error (&_inner_error_);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			return 0;
#line 320 "nuvolaplayer-client.c"
		}
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_g_object_unref0 (player);
#line 62 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		player = _tmp9_;
#line 326 "nuvolaplayer-client.c"
	}
	goto __finally1;
	__catch1_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		GError* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		e = _inner_error_;
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_inner_error_ = NULL;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp11_ = stderr;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp12_ = _ ("Unable to connect to player interface: %s\n");
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp13_ = e;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp14_ = _tmp13_->message;
#line 66 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		fprintf (_tmp11_, _tmp12_, _tmp14_);
#line 67 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		result = 1;
#line 67 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_g_error_free0 (e);
#line 67 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		return result;
#line 356 "nuvolaplayer-client.c"
	}
	__finally1:
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	if (_inner_error_ != NULL) {
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		g_clear_error (&_inner_error_);
#line 61 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		return 0;
#line 367 "nuvolaplayer-client.c"
	}
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp15_ = args;
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp15__length1 = args_length1;
#line 70 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	if (_tmp15__length1 == 1) {
#line 375 "nuvolaplayer-client.c"
		const gchar* _tmp16_ = NULL;
#line 71 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp16_ = prog_name;
#line 71 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		usage (_tmp16_, NULL);
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		result = 1;
#line 72 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		return result;
#line 385 "nuvolaplayer-client.c"
	} else {
		gchar** _tmp17_ = NULL;
		gint _tmp17__length1 = 0;
#line 74 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp17_ = args;
#line 74 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp17__length1 = args_length1;
#line 74 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		if (_tmp17__length1 > 2) {
#line 395 "nuvolaplayer-client.c"
			const gchar* _tmp18_ = NULL;
			const gchar* _tmp19_ = NULL;
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			_tmp18_ = prog_name;
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			_tmp19_ = _ ("Wrong number of arguments.\n");
#line 76 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			usage (_tmp18_, _tmp19_);
#line 77 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			result = 1;
#line 77 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			return result;
#line 408 "nuvolaplayer-client.c"
		}
	}
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp20_ = args;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp20__length1 = args_length1;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp21_ = _tmp20_[1];
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp23_ = call_command (_tmp21_, &_tmp22_);
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	exit_code = _tmp22_;
#line 81 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	if (!_tmp23_) {
#line 423 "nuvolaplayer-client.c"
		FILE* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp24_ = stderr;
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp25_ = _ ("Unable to connect to the Remote Player Interface of Nuvola Player.");
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp26_ = _ ("Make sure Nuvola Player is running and extension 'Remote Player Interf" \
"ace' is enabled in the Preferences dialog.");
#line 83 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		fprintf (_tmp24_, "\n%s\n%s\n", _tmp25_, _tmp26_);
#line 86 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		result = 2;
#line 86 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		return result;
#line 439 "nuvolaplayer-client.c"
	}
#line 89 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	result = exit_code;
#line 89 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	return result;
#line 445 "nuvolaplayer-client.c"
}


int main (int argc, char ** argv) {
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_thread_init (NULL);
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_type_init ();
#line 44 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	return _vala_main (argv, argc);
#line 456 "nuvolaplayer-client.c"
}


/**
 * Call client command.
 * 
 * @param cmd				command to execute
 * @param return_code	application exit code
 * @return					false if call failed because of invalid DBus proxy object,
 * 							true otherwise
 */
gboolean call_command (const gchar* cmd, gint* exit_code) {
	gint _vala_exit_code = 0;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 100 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_val_if_fail (cmd != NULL, FALSE);
#line 101 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_vala_exit_code = -1;
#line 476 "nuvolaplayer-client.c"
	{
		const gchar* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		GQuark _tmp3_ = 0U;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		static GQuark _tmp2_label0 = 0;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		static GQuark _tmp2_label1 = 0;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		static GQuark _tmp2_label2 = 0;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		static GQuark _tmp2_label3 = 0;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		static GQuark _tmp2_label4 = 0;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		static GQuark _tmp2_label5 = 0;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		static GQuark _tmp2_label6 = 0;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		static GQuark _tmp2_label7 = 0;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp0_ = cmd;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp1_ = _tmp0_;
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("play")))) {
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			switch (0) {
#line 507 "nuvolaplayer-client.c"
				default:
				{
					MPRISPlayer* _tmp4_ = NULL;
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp4_ = player;
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					mpris_player_play (_tmp4_, &_inner_error_);
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					if (_inner_error_ != NULL) {
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (_inner_error_->domain == G_IO_ERROR) {
#line 519 "nuvolaplayer-client.c"
							goto __catch2_g_io_error;
						}
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_clear_error (&_inner_error_);
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						return FALSE;
#line 528 "nuvolaplayer-client.c"
					}
#line 107 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					break;
#line 532 "nuvolaplayer-client.c"
				}
			}
		} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("pause")))) {
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			switch (0) {
#line 538 "nuvolaplayer-client.c"
				default:
				{
					MPRISPlayer* _tmp5_ = NULL;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp5_ = player;
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					mpris_player_pause (_tmp5_, &_inner_error_);
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					if (_inner_error_ != NULL) {
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (_inner_error_->domain == G_IO_ERROR) {
#line 550 "nuvolaplayer-client.c"
							goto __catch2_g_io_error;
						}
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_clear_error (&_inner_error_);
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						return FALSE;
#line 559 "nuvolaplayer-client.c"
					}
#line 108 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					break;
#line 563 "nuvolaplayer-client.c"
				}
			}
		} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("toggle")))) {
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			switch (0) {
#line 569 "nuvolaplayer-client.c"
				default:
				{
					MPRISPlayer* _tmp6_ = NULL;
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp6_ = player;
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					mpris_player_play_pause (_tmp6_, &_inner_error_);
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					if (_inner_error_ != NULL) {
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (_inner_error_->domain == G_IO_ERROR) {
#line 581 "nuvolaplayer-client.c"
							goto __catch2_g_io_error;
						}
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_clear_error (&_inner_error_);
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						return FALSE;
#line 590 "nuvolaplayer-client.c"
					}
#line 109 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					break;
#line 594 "nuvolaplayer-client.c"
				}
			}
		} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("next")))) {
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			switch (0) {
#line 600 "nuvolaplayer-client.c"
				default:
				{
					MPRISPlayer* _tmp7_ = NULL;
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp7_ = player;
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					mpris_player_next (_tmp7_, &_inner_error_);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					if (_inner_error_ != NULL) {
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (_inner_error_->domain == G_IO_ERROR) {
#line 612 "nuvolaplayer-client.c"
							goto __catch2_g_io_error;
						}
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						return FALSE;
#line 621 "nuvolaplayer-client.c"
					}
#line 110 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					break;
#line 625 "nuvolaplayer-client.c"
				}
			}
		} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("prev")))) {
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			switch (0) {
#line 631 "nuvolaplayer-client.c"
				default:
				{
					MPRISPlayer* _tmp8_ = NULL;
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp8_ = player;
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					mpris_player_previous (_tmp8_, &_inner_error_);
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					if (_inner_error_ != NULL) {
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (_inner_error_->domain == G_IO_ERROR) {
#line 643 "nuvolaplayer-client.c"
							goto __catch2_g_io_error;
						}
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_clear_error (&_inner_error_);
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						return FALSE;
#line 652 "nuvolaplayer-client.c"
					}
#line 111 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					break;
#line 656 "nuvolaplayer-client.c"
				}
			}
		} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("raise")))) {
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			switch (0) {
#line 662 "nuvolaplayer-client.c"
				default:
				{
					MPRISApplication* _tmp9_ = NULL;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp9_ = app;
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					mpris_application_raise (_tmp9_, &_inner_error_);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					if (_inner_error_ != NULL) {
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (_inner_error_->domain == G_IO_ERROR) {
#line 674 "nuvolaplayer-client.c"
							goto __catch2_g_io_error;
						}
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_clear_error (&_inner_error_);
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						return FALSE;
#line 683 "nuvolaplayer-client.c"
					}
#line 112 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					break;
#line 687 "nuvolaplayer-client.c"
				}
			}
		} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("quit")))) {
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			switch (0) {
#line 693 "nuvolaplayer-client.c"
				default:
				{
					MPRISApplication* _tmp10_ = NULL;
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp10_ = app;
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					mpris_application_quit (_tmp10_, &_inner_error_);
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					if (_inner_error_ != NULL) {
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (_inner_error_->domain == G_IO_ERROR) {
#line 705 "nuvolaplayer-client.c"
							goto __catch2_g_io_error;
						}
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						g_clear_error (&_inner_error_);
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						return FALSE;
#line 714 "nuvolaplayer-client.c"
					}
#line 113 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					break;
#line 718 "nuvolaplayer-client.c"
				}
			}
		} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("status")))) {
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			switch (0) {
#line 724 "nuvolaplayer-client.c"
				default:
				{
					gchar* status = NULL;
					MPRISPlayer* _tmp11_ = NULL;
					gchar* _tmp12_ = NULL;
					gchar* _tmp13_ = NULL;
					FILE* _tmp14_ = NULL;
					const gchar* _tmp15_ = NULL;
					const gchar* _tmp16_ = NULL;
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp11_ = player;
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp12_ = mpris_player_get_playback_status (_tmp11_);
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp13_ = _tmp12_;
#line 115 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					status = _tmp13_;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp14_ = stdout;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp15_ = status;
#line 116 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					fprintf (_tmp14_, "Status: %s\n", _tmp15_);
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp16_ = status;
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					if (g_strcmp0 (_tmp16_, "Stopped") != 0) {
#line 752 "nuvolaplayer-client.c"
						GHashTable* metadata = NULL;
						MPRISPlayer* _tmp17_ = NULL;
						GHashTable* _tmp18_ = NULL;
						GHashTable* _tmp19_ = NULL;
						gchar* song = NULL;
						GHashTable* _tmp20_ = NULL;
						gconstpointer _tmp21_ = NULL;
						const gchar* _tmp22_ = NULL;
						gchar* _tmp23_ = NULL;
						const gchar* _tmp24_ = NULL;
						gchar** artistArray = NULL;
						GHashTable* _tmp28_ = NULL;
						gconstpointer _tmp29_ = NULL;
						size_t _tmp30_;
						gchar** _tmp31_ = NULL;
						gint artistArray_length1 = 0;
						gint _artistArray_size_ = 0;
						const gchar* _tmp32_ = NULL;
						gchar** _tmp33_ = NULL;
						gint _tmp33__length1 = 0;
						gchar* artist = NULL;
						const gchar* _tmp36_ = NULL;
						gchar* _tmp37_ = NULL;
						const gchar* _tmp38_ = NULL;
						gchar* album = NULL;
						GHashTable* _tmp42_ = NULL;
						gconstpointer _tmp43_ = NULL;
						const gchar* _tmp44_ = NULL;
						gchar* _tmp45_ = NULL;
						const gchar* _tmp46_ = NULL;
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp17_ = player;
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp18_ = mpris_player_get_metadata (_tmp17_);
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp19_ = _tmp18_;
#line 118 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						metadata = _tmp19_;
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp20_ = metadata;
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp21_ = g_hash_table_lookup (_tmp20_, "xesam:title");
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp22_ = g_variant_get_string ((GVariant*) _tmp21_, NULL);
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp23_ = g_strdup (_tmp22_);
#line 120 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						song = _tmp23_;
#line 121 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp24_ = song;
#line 121 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (g_strcmp0 (_tmp24_, "") != 0) {
#line 805 "nuvolaplayer-client.c"
							FILE* _tmp25_ = NULL;
							const gchar* _tmp26_ = NULL;
							const gchar* _tmp27_ = NULL;
#line 123 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp25_ = stdout;
#line 123 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp26_ = _ ("Song: %s\n");
#line 123 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp27_ = song;
#line 123 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							fprintf (_tmp25_, _tmp26_, _tmp27_);
#line 817 "nuvolaplayer-client.c"
						}
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp28_ = metadata;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp29_ = g_hash_table_lookup (_tmp28_, "xesam:artist");
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp31_ = g_variant_dup_strv ((GVariant*) _tmp29_, &_tmp30_);
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						artistArray = _tmp31_;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						artistArray_length1 = _tmp30_;
#line 126 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_artistArray_size_ = artistArray_length1;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp33_ = artistArray;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp33__length1 = artistArray_length1;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (_tmp33__length1 > 0) {
#line 837 "nuvolaplayer-client.c"
							gchar** _tmp34_ = NULL;
							gint _tmp34__length1 = 0;
							const gchar* _tmp35_ = NULL;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp34_ = artistArray;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp34__length1 = artistArray_length1;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp35_ = _tmp34_[0];
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp32_ = _tmp35_;
#line 849 "nuvolaplayer-client.c"
						} else {
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp32_ = "";
#line 853 "nuvolaplayer-client.c"
						}
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp36_ = _tmp32_;
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp37_ = g_strdup (_tmp36_);
#line 127 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						artist = _tmp37_;
#line 128 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp38_ = artist;
#line 128 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (g_strcmp0 (_tmp38_, "") != 0) {
#line 865 "nuvolaplayer-client.c"
							FILE* _tmp39_ = NULL;
							const gchar* _tmp40_ = NULL;
							const gchar* _tmp41_ = NULL;
#line 130 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp39_ = stdout;
#line 130 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp40_ = _ ("Artist: %s\n");
#line 130 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp41_ = artist;
#line 130 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							fprintf (_tmp39_, _tmp40_, _tmp41_);
#line 877 "nuvolaplayer-client.c"
						}
#line 133 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp42_ = metadata;
#line 133 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp43_ = g_hash_table_lookup (_tmp42_, "xesam:album");
#line 133 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp44_ = g_variant_get_string ((GVariant*) _tmp43_, NULL);
#line 133 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp45_ = g_strdup (_tmp44_);
#line 133 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						album = _tmp45_;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_tmp46_ = album;
#line 134 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						if (g_strcmp0 (_tmp46_, "") != 0) {
#line 893 "nuvolaplayer-client.c"
							FILE* _tmp47_ = NULL;
							const gchar* _tmp48_ = NULL;
							const gchar* _tmp49_ = NULL;
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp47_ = stdout;
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp48_ = _ ("Album: %s\n");
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							_tmp49_ = album;
#line 136 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
							fprintf (_tmp47_, _tmp48_, _tmp49_);
#line 905 "nuvolaplayer-client.c"
						}
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_g_free0 (album);
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_g_free0 (artist);
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						artistArray = (_vala_array_free (artistArray, artistArray_length1, (GDestroyNotify) g_free), NULL);
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_g_free0 (song);
#line 117 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						_g_hash_table_unref0 (metadata);
#line 917 "nuvolaplayer-client.c"
					}
#line 140 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_g_free0 (status);
#line 140 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					break;
#line 923 "nuvolaplayer-client.c"
				}
			}
		} else {
#line 106 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			switch (0) {
#line 929 "nuvolaplayer-client.c"
				default:
				{
					const gchar* _tmp50_ = NULL;
					const gchar* _tmp51_ = NULL;
					const gchar* _tmp52_ = NULL;
					gchar* _tmp53_ = NULL;
					gchar* _tmp54_ = NULL;
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp50_ = prog_name;
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp51_ = _ ("Wrong argument: %s\n");
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp52_ = cmd;
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp53_ = g_strdup_printf (_tmp51_, _tmp52_);
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_tmp54_ = _tmp53_;
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					usage (_tmp50_, _tmp54_);
#line 143 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_g_free0 (_tmp54_);
#line 144 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					_vala_exit_code = 1;
#line 145 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					result = TRUE;
#line 145 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					if (exit_code) {
#line 145 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
						*exit_code = _vala_exit_code;
#line 959 "nuvolaplayer-client.c"
					}
#line 145 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
					return result;
#line 963 "nuvolaplayer-client.c"
				}
			}
		}
	}
	goto __finally2;
	__catch2_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp55_ = NULL;
		const gchar* _tmp56_ = NULL;
		GError* _tmp57_ = NULL;
		const gchar* _tmp58_ = NULL;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		e = _inner_error_;
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_inner_error_ = NULL;
#line 150 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp55_ = stderr;
#line 150 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp56_ = cmd;
#line 150 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp57_ = e;
#line 150 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp58_ = _tmp57_->message;
#line 150 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		fprintf (_tmp55_, "Unable to execute command %1$s: %2$s\n", _tmp56_, _tmp58_);
#line 151 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_vala_exit_code = 1;
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		result = TRUE;
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_g_error_free0 (e);
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		if (exit_code) {
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
			*exit_code = _vala_exit_code;
#line 1000 "nuvolaplayer-client.c"
		}
#line 152 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		return result;
#line 1004 "nuvolaplayer-client.c"
	}
	__finally2:
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	if (_inner_error_ != NULL) {
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		g_clear_error (&_inner_error_);
#line 105 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		return FALSE;
#line 1015 "nuvolaplayer-client.c"
	}
#line 155 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_vala_exit_code = 0;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	result = TRUE;
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	if (exit_code) {
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		*exit_code = _vala_exit_code;
#line 1025 "nuvolaplayer-client.c"
	}
#line 156 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	return result;
#line 1029 "nuvolaplayer-client.c"
}


void usage (const gchar* command, const gchar* _error_) {
	const gchar* _tmp0_ = NULL;
	FILE* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
#line 159 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (command != NULL);
#line 160 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp0_ = _error_;
#line 160 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	if (_tmp0_ != NULL) {
#line 1043 "nuvolaplayer-client.c"
		FILE* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		FILE* _tmp3_ = NULL;
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp1_ = stderr;
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp2_ = _error_;
#line 161 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		fputs (_tmp2_, _tmp1_);
#line 162 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		_tmp3_ = stderr;
#line 162 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		fputs ("\n", _tmp3_);
#line 1057 "nuvolaplayer-client.c"
	}
#line 165 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp4_ = stderr;
#line 165 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	_tmp5_ = command;
#line 165 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	fprintf (_tmp4_, "Usage:\n" \
"  %s [COMMAND]\n" \
"\n" \
"Available commands:\n" \
"  status    print current status (playback state, song info)\n" \
"  play      start playback\n" \
"  pause     pause playback\n" \
"  toggle    toggle play/pause\n" \
"  next      skip to next song\n" \
"  prev      skip to previous song\n" \
"  raise     raise Nuvola Player window\n" \
"  quit      quit Nuvola Player\n", _tmp5_);
#line 1065 "nuvolaplayer-client.c"
}


void mpris_application_raise (MPRISApplication* self, GError** error) {
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 182 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_APPLICATION_GET_INTERFACE (self)->raise (self, error);
#line 1074 "nuvolaplayer-client.c"
}


void mpris_application_quit (MPRISApplication* self, GError** error) {
#line 183 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 183 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_APPLICATION_GET_INTERFACE (self)->quit (self, error);
#line 1083 "nuvolaplayer-client.c"
}


static void mpris_application_base_init (MPRISApplicationIface * iface) {
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	static gboolean initialized = FALSE;
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	if (!initialized) {
#line 181 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		initialized = TRUE;
#line 1094 "nuvolaplayer-client.c"
	}
}


GType mpris_application_get_type (void) {
	static volatile gsize mpris_application_type_id__volatile = 0;
	if (g_once_init_enter (&mpris_application_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MPRISApplicationIface), (GBaseInitFunc) mpris_application_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType mpris_application_type_id;
		mpris_application_type_id = g_type_register_static (G_TYPE_INTERFACE, "MPRISApplication", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (mpris_application_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (mpris_application_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) mpris_application_proxy_get_type);
		g_type_set_qdata (mpris_application_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.mpris.MediaPlayer2");
		g_type_set_qdata (mpris_application_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_application_register_object);
		g_once_init_leave (&mpris_application_type_id__volatile, mpris_application_type_id);
	}
	return mpris_application_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (MPRISApplicationProxy, mpris_application_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_MPRIS_APPLICATION, mpris_application_proxy_mpris_application_interface_init) )
static void mpris_application_proxy_class_init (MPRISApplicationProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = mpris_application_proxy_g_signal;
}


static void mpris_application_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
}


static void mpris_application_proxy_init (MPRISApplicationProxy* self) {
}


static void mpris_application_proxy_raise (MPRISApplication* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2", "Raise");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void mpris_application_proxy_quit (MPRISApplication* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2", "Quit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void mpris_application_proxy_mpris_application_interface_init (MPRISApplicationIface* iface) {
	iface->raise = mpris_application_proxy_raise;
	iface->quit = mpris_application_proxy_quit;
}


static void _dbus_mpris_application_raise (MPRISApplication* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_application_raise (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_application_quit (MPRISApplication* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_application_quit (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void mpris_application_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Raise") == 0) {
		_dbus_mpris_application_raise (object, parameters, invocation);
	} else if (strcmp (method_name, "Quit") == 0) {
		_dbus_mpris_application_quit (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* mpris_application_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean mpris_application_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint mpris_application_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_application_dbus_interface_info), &_mpris_application_dbus_interface_vtable, data, _mpris_application_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _mpris_application_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


void mpris_player_next (MPRISPlayer* self, GError** error) {
#line 190 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 190 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_PLAYER_GET_INTERFACE (self)->next (self, error);
#line 1288 "nuvolaplayer-client.c"
}


void mpris_player_previous (MPRISPlayer* self, GError** error) {
#line 191 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 191 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_PLAYER_GET_INTERFACE (self)->previous (self, error);
#line 1297 "nuvolaplayer-client.c"
}


void mpris_player_pause (MPRISPlayer* self, GError** error) {
#line 192 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 192 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_PLAYER_GET_INTERFACE (self)->pause (self, error);
#line 1306 "nuvolaplayer-client.c"
}


void mpris_player_play_pause (MPRISPlayer* self, GError** error) {
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 193 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_PLAYER_GET_INTERFACE (self)->play_pause (self, error);
#line 1315 "nuvolaplayer-client.c"
}


void mpris_player_stop (MPRISPlayer* self, GError** error) {
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 194 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_PLAYER_GET_INTERFACE (self)->stop (self, error);
#line 1324 "nuvolaplayer-client.c"
}


void mpris_player_play (MPRISPlayer* self, GError** error) {
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 195 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_PLAYER_GET_INTERFACE (self)->play (self, error);
#line 1333 "nuvolaplayer-client.c"
}


gchar* mpris_player_get_playback_status (MPRISPlayer* self) {
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	return MPRIS_PLAYER_GET_INTERFACE (self)->get_playback_status (self);
#line 1342 "nuvolaplayer-client.c"
}


static void mpris_player_set_playback_status (MPRISPlayer* self, const gchar* value) {
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 188 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_PLAYER_GET_INTERFACE (self)->set_playback_status (self, value);
#line 1351 "nuvolaplayer-client.c"
}


GHashTable* mpris_player_get_metadata (MPRISPlayer* self) {
#line 189 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 189 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	return MPRIS_PLAYER_GET_INTERFACE (self)->get_metadata (self);
#line 1360 "nuvolaplayer-client.c"
}


static void mpris_player_set_metadata (MPRISPlayer* self, GHashTable* value) {
#line 189 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	g_return_if_fail (self != NULL);
#line 189 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	MPRIS_PLAYER_GET_INTERFACE (self)->set_metadata (self, value);
#line 1369 "nuvolaplayer-client.c"
}


static void mpris_player_base_init (MPRISPlayerIface * iface) {
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	static gboolean initialized = FALSE;
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
	if (!initialized) {
#line 187 "/builddir/build/BUILD/nuvolaplayer-2.5/src/nuvolaplayer-client.vala"
		initialized = TRUE;
#line 1380 "nuvolaplayer-client.c"
	}
}


GType mpris_player_get_type (void) {
	static volatile gsize mpris_player_type_id__volatile = 0;
	if (g_once_init_enter (&mpris_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MPRISPlayerIface), (GBaseInitFunc) mpris_player_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType mpris_player_type_id;
		mpris_player_type_id = g_type_register_static (G_TYPE_INTERFACE, "MPRISPlayer", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (mpris_player_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (mpris_player_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) mpris_player_proxy_get_type);
		g_type_set_qdata (mpris_player_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.mpris.MediaPlayer2.Player");
		g_type_set_qdata (mpris_player_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mpris_player_register_object);
		g_once_init_leave (&mpris_player_type_id__volatile, mpris_player_type_id);
	}
	return mpris_player_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (MPRISPlayerProxy, mpris_player_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_MPRIS_PLAYER, mpris_player_proxy_mpris_player_interface_init) )
static void mpris_player_proxy_class_init (MPRISPlayerProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = mpris_player_proxy_g_signal;
}


static void mpris_player_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
}


static void mpris_player_proxy_init (MPRISPlayerProxy* self) {
}


static void mpris_player_proxy_next (MPRISPlayer* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "Next");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void mpris_player_proxy_previous (MPRISPlayer* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "Previous");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void mpris_player_proxy_pause (MPRISPlayer* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "Pause");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void mpris_player_proxy_play_pause (MPRISPlayer* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "PlayPause");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void mpris_player_proxy_stop (MPRISPlayer* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "Stop");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void mpris_player_proxy_play (MPRISPlayer* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "Play");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static gchar* mpris_player_dbus_proxy_get_playback_status (MPRISPlayer* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "PlaybackStatus");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PlaybackStatus"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void mpris_player_dbus_proxy_set_playback_status (MPRISPlayer* self, const gchar* value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PlaybackStatus"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static GHashTable* mpris_player_dbus_proxy_get_metadata (MPRISPlayer* self) {
	GVariant *_inner_reply;
	GHashTable* _result;
	GHashTable* _tmp0_;
	GVariantIter _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Metadata");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Metadata"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_tmp0_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp1_, _inner_reply);
	while (g_variant_iter_loop (&_tmp1_, "{?*}", &_tmp2_, &_tmp3_)) {
		g_hash_table_insert (_tmp0_, g_variant_dup_string (_tmp2_, NULL), g_variant_get_variant (_tmp3_));
	}
	_result = _tmp0_;
	g_variant_unref (_inner_reply);
	return _result;
}


static void mpris_player_dbus_proxy_set_metadata (MPRISPlayer* self, GHashTable* value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp4_;
	GHashTableIter _tmp5_;
	gpointer _tmp6_;
	gpointer _tmp7_;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Metadata"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_hash_table_iter_init (&_tmp5_, value);
	g_variant_builder_init (&_tmp4_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp5_, &_tmp6_, &_tmp7_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp6_;
		_value = (GVariant*) _tmp7_;
		g_variant_builder_add (&_tmp4_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp4_));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static void mpris_player_proxy_mpris_player_interface_init (MPRISPlayerIface* iface) {
	iface->next = mpris_player_proxy_next;
	iface->previous = mpris_player_proxy_previous;
	iface->pause = mpris_player_proxy_pause;
	iface->play_pause = mpris_player_proxy_play_pause;
	iface->stop = mpris_player_proxy_stop;
	iface->play = mpris_player_proxy_play;
	iface->get_playback_status = mpris_player_dbus_proxy_get_playback_status;
	iface->set_playback_status = mpris_player_dbus_proxy_set_playback_status;
	iface->get_metadata = mpris_player_dbus_proxy_get_metadata;
	iface->set_metadata = mpris_player_dbus_proxy_set_metadata;
}


static void _dbus_mpris_player_next (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_next (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_previous (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_previous (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_pause (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_pause (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_play_pause (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_play_pause (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_stop (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_stop (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_mpris_player_play (MPRISPlayer* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	mpris_player_play (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void mpris_player_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Next") == 0) {
		_dbus_mpris_player_next (object, parameters, invocation);
	} else if (strcmp (method_name, "Previous") == 0) {
		_dbus_mpris_player_previous (object, parameters, invocation);
	} else if (strcmp (method_name, "Pause") == 0) {
		_dbus_mpris_player_pause (object, parameters, invocation);
	} else if (strcmp (method_name, "PlayPause") == 0) {
		_dbus_mpris_player_play_pause (object, parameters, invocation);
	} else if (strcmp (method_name, "Stop") == 0) {
		_dbus_mpris_player_stop (object, parameters, invocation);
	} else if (strcmp (method_name, "Play") == 0) {
		_dbus_mpris_player_play (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* _dbus_mpris_player_get_playback_status (MPRISPlayer* self) {
	gchar* result;
	GVariant* _reply;
	result = mpris_player_get_playback_status (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_mpris_player_get_metadata (MPRISPlayer* self) {
	GHashTable* result;
	GVariantBuilder _tmp8_;
	GHashTableIter _tmp9_;
	gpointer _tmp10_;
	gpointer _tmp11_;
	GVariant* _reply;
	result = mpris_player_get_metadata (self);
	g_hash_table_iter_init (&_tmp9_, result);
	g_variant_builder_init (&_tmp8_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp9_, &_tmp10_, &_tmp11_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp10_;
		_value = (GVariant*) _tmp11_;
		g_variant_builder_add (&_tmp8_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	_reply = g_variant_builder_end (&_tmp8_);
	_g_hash_table_unref0 (result);
	return _reply;
}


static GVariant* mpris_player_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaybackStatus") == 0) {
		return _dbus_mpris_player_get_playback_status (object);
	} else if (strcmp (property_name, "Metadata") == 0) {
		return _dbus_mpris_player_get_metadata (object);
	}
	return NULL;
}


static void _dbus_mpris_player_set_playback_status (MPRISPlayer* self, GVariant* _value) {
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	mpris_player_set_playback_status (self, value);
	_g_free0 (value);
}


static void _dbus_mpris_player_set_metadata (MPRISPlayer* self, GVariant* _value) {
	GHashTable* value = NULL;
	GHashTable* _tmp12_;
	GVariantIter _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	_tmp12_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp13_, _value);
	while (g_variant_iter_loop (&_tmp13_, "{?*}", &_tmp14_, &_tmp15_)) {
		g_hash_table_insert (_tmp12_, g_variant_dup_string (_tmp14_, NULL), g_variant_get_variant (_tmp15_));
	}
	value = _tmp12_;
	mpris_player_set_metadata (self, value);
	_g_hash_table_unref0 (value);
}


static gboolean mpris_player_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaybackStatus") == 0) {
		_dbus_mpris_player_set_playback_status (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Metadata") == 0) {
		_dbus_mpris_player_set_metadata (object, value);
		return TRUE;
	}
	return FALSE;
}


guint mpris_player_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mpris_player_dbus_interface_info), &_mpris_player_dbus_interface_vtable, data, _mpris_player_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _mpris_player_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



